/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "gdinar.pas" */


#include <p2c/p2c.h>


#define GDINAR_G
#include "gdinar.h"


Void _HazIndice(nDim, IX)
uchar nDim;
short **IX;
{
  *IX = (short *)Malloc(nDim * sizeof(short));
}


Void _DestruIndice(nDim, IX)
uchar nDim;
short **IX;
{
/* p2c: gdinar.pas, line 29:
 * Warning: Too many arguments for freemem [299] */
  Free(*IX);
}


Static short Dir(X, I)
_Arreglo *X;
short *I;
{
  short Desplaz, j, FORLIM;

  Desplaz = I[0] - 1;
  FORLIM = X->nDim;
  for (j = 1; j <= FORLIM - 1; j++)
    Desplaz = Desplaz * X->Rango[j] + I[j] - 1;
  return Desplaz;
}  /*Dir*/


Static double v(X, I)
_Arreglo *X;
short *I;
{
  return (X->Base[Dir(X, I)]);
}


Static Void g(X, I, valor)
_Arreglo *X;
short *I;
double valor;
{
  X->Base[Dir(X, I)] = valor;
}


Void _Definir(X, Direc, nD, Dims)
_Arreglo *X;
double *Direc;
short nD;
short *Dims;
{
  short j;
  short Tama = 1;
  short FORLIM;

  X->nDim = nD;
  X->Rango = (short *)Malloc(X->nDim * sizeof(short));
  FORLIM = X->nDim;
  for (j = 0; j <= FORLIM - 1; j++) {
    X->Rango[j] = Dims[j];
    Tama *= Dims[j];
  }
  if (Direc != NULL) {
    X->Base = Direc;
    return;
  }
  X->Base = (double *)Malloc(Tama * sizeof(double));
  if (X->Base == NULL) {
    printf("MEMORIA EXCEDIDA: \n");
    _Escape(0);
  }
}  /*Definir*/


Static Void ProxOrden(X, IX, Orden, Tope, Completo)
_Arreglo *X;
short *IX, *Orden;
short Tope;
boolean *Completo;
{
  /*Tope es el numero de posiciones de indice que hay en Orden;
    en Orden se colocan los indices de izquierda a derecha, el mas lento
    el mas a la izquierda*/
  boolean SeIncremento = false;
  short i = Tope;

  while (!SeIncremento) {
    if (IX[Orden[i-1] - 1] != X->Rango[Orden[i-1] - 1]) {
      IX[Orden[i-1] - 1]++;
      SeIncremento = true;
      break;
    }
    if (i > 1) {
      IX[Orden[i-1] - 1] = 1;
      i--;
    } else {
      SeIncremento = true;
      *Completo = true;
    }
  }
}  /*ProxOrden*/


Void _DistriConj(A)
_Arreglo *A;
{
  short i, j;
  boolean Completo, Completo2;
  short *IX, *Orden, *Orden2;
  double s;
  short FORLIM1;

  /*Distribucion Conjunta en A */
  _HazIndice(A->nDim, &IX);
  _HazIndice(A->nDim, &Orden);
  _HazIndice(A->nDim, &Orden2);
  for (j = A->nDim; j >= 1; j--) {
    for (i = 1; i <= j - 1; i++) {
      IX[i-1] = 1;
      Orden[i-1] = i;
    }
    Orden2[0] = j;
    FORLIM1 = A->nDim;
    for (i = j; i <= FORLIM1 - 1; i++)
      IX[i] = A->Rango[i];
    Completo = false;
    do {
      s = 0.0;
      Completo2 = false;
      IX[j-1] = 1;
      do {
	s += v(A, IX);
	g(A, IX, s);
	ProxOrden(A, IX, Orden2, 1, &Completo2);
      } while (!Completo2);
      Completo2 = false;
      IX[j-1] = 1;
      do {
	g(A, IX, v(A, IX) / s);
	ProxOrden(A, IX, Orden2, 1, &Completo2);
      } while (!Completo2);
      g(A, IX, s);
      if (j > 1)
	ProxOrden(A, IX, Orden, j - 1, &Completo);
      else
	Completo = true;
    } while (!Completo);
  }
  _DestruIndice(A->nDim, &IX);
  _DestruIndice(A->nDim, &Orden);
  _DestruIndice(A->nDim, &Orden2);
}  /*DistriConj*/


Void _SeleDistriConj(A, semilla, Dims)
_Arreglo *A;
short semilla;
short *Dims;
{
  short i, j;
  boolean Completo;
  short *IX, *Orden;
  double p, vA;
  short FORLIM;

  _HazIndice(A->nDim, &IX);
  _HazIndice(A->nDim, &Orden);
  FORLIM = A->nDim;
  for (i = 0; i <= FORLIM - 1; i++)
    IX[i] = A->Rango[i];
  FORLIM = A->nDim;
  for (j = 0; j <= FORLIM - 1; j++) {
    Orden[0] = j + 1;
    IX[j] = 1;
    Completo = false;
    p = rnd(semilla);
    do {
      if (IX[j] < A->Rango[j]) {
	vA = v(A, IX);
	if (p <= vA) {
	  Completo = true;
	  Dims[j] = IX[j];
	} else
	  ProxOrden(A, IX, Orden, 1, &Completo);
      } else {
	Completo = true;
	Dims[j] = IX[j];
      }
    } while (!Completo);
  }
  _DestruIndice(A->nDim, &IX);
  _DestruIndice(A->nDim, &Orden);
}  /*SeleDistriConj*/




/* End. */
