/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "pp.pas" */


#include <p2c/p2c.h>


#define PP_G
#include "pp.h"


double escax = 0.9, escay = 0.7;
Char _nume[8] = "       ";

Opcion CMENUENSAL[6] = {
  { "Initialize and run", 1 },
  { "set Title of experiment", 5 },
  { "make Replications", 6 },
  { "Graphic", 1 },
  { "set Aditional time", 5 },
  { "Quit", 1 }
};

Opcion CMENUPRIN[9] = {
  { "Continue", 1 },
  { "initialize Statistics and continue", 12 },
  { "read Experiment and continue", 6 },
  { "Write statistics", 1 },
  { "Display Future Event List", 1 },
  { "Display or Skip statistics after replication", 1 },
  { "Trace", 1 },
  { "Graphic", 1 },
  { "Quit", 1 }
};

Opcion CMENUSTAT[5] = {
  { "Repeat Statistics", 1 },
  { "Continue", 1 },
  { "Menu", 1 },
  { "Frequency Tables", 1 },
  { "Graphic", 1 }
};

#ifndef GDINAR_H
#include "gdinar.h"
#endif

#ifndef PRU_H
#include "pru.h"
#endif


Void _iniass(list)
short list;
{
  /*inicializar SINCHR or ASSEMBLE*/
  _ac1 = _acc;
  sync = false;
  _pu = _fl[list-1];
}


Void _exaprisi()
{
  /*LINUX begin _aas:=false; _exal(_pu); _uprv(_pu^.r,_pu^.b,_pu^.d);*/
  _aas = false;
  _exal(_pu);
  _uprv(_pu->r, _pu->b);
}


Void _ilimess(list)
short list;
{
  /*LINUX begin _extr(_pu,list); _elim(_pu^.r,_pu^.b,_pu^.d,_pu);*/
  _extr(&_pu, list);
  _elim(_pu->r, _pu->b, _pu);
}


Void _inici()
{
  /*inicializar opcion I del menu de entrada y salida*/
  _bsc = false;   /*10/4/1998*/
  _rep = false;   /*equivale a 'I'*/
  inisem();   /*inicializar semillas de numeros aleatorios*/
  _ut = ' ';
  if (!strcmp(TITLE, " "))
    strcpy(TITLE, "Basic Experiment");
  _inieli();
  _com();
  clrstat();
  /*LINUX*/
  _ginit();
}


Static Void initra()
{
  /*inicializar el TRACE*/
  Char _nftr[31];
  Char _cht, *TEMP;

  _bt = true;
  gotoxy(10, 30);
  printf("File the trace? Y/N");
  _cht = toupper(getch());
  putchar('\n');
  if (_cht != 'Y') {
    _bftr = false;
    return;
  }
  gotoxy(10, 30);
  printf("Filename for trace?    ");
  fgets(_nftr, 31, stdin);
  TEMP = strchr(_nftr, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  strcpy(_ftra_NAME, _nftr);
  if (_ftra != NULL)
    _ftra = freopen(_ftra_NAME, "w", _ftra);
  else
    _ftra = fopen(_ftra_NAME, "w");
  if (_ftra == NULL)
    _EscIO2(FileNotFound, _ftra_NAME);
  _bftr = true;
}


Static Void _PREMENUST()
{
  /*preparar menu de estadisticas*/
  clrscr();
  _bmen = false;   /*BLACK,WHITE*/
  /*LINUX TEXTCOLOR(yellow); TEXTBACKGROUND(blue);*/
  Ventana_MainPort(&VPRINCIPAL, Blue, Yellow);
  MenuS_Init(&MENUSTAT, 5, 5, 24, 26, 7, Cyan, White);
  MenuS_DefiOpcios(&MENUSTAT, CMENUSTAT);
  QUIT = false;
  do {
    SELE = MenuS_Selec(&MENUSTAT);
  } while (SELE <= 0);

}


/* Local variables for stat: */
struct LOC_stat {
  uchar _cl;
  double _d, _dp;
} ;

Local Void conlin(LINK)
struct LOC_stat *LINK;
{
  /*continuar escribiendo lineas*/
  Char _ut;

  if (LINK->_cl < 16)
    return;
  printf("Press any key to continue output table");
  _ut = getch();
  LINK->_cl = 2;

  if (strcmp(_nomars, "CON"))
    return;
  /*LINUX CLRSCR;*/
  gotoxy(1, wherey - 1);
  putchar('\n');
  fprintf(_ars, "Var/Ind                 Mean      Dev.    Max.      Min.\n");
}


Local Void rncien(v, LINK)
double v;
struct LOC_stat *LINK;
{
  /*reduce a notacion decimal o exponencial */
  short n = 0;
  short k;
  Char sg = '+';
  Char sv;
  double w;

  if (v >= 0)
    sv = ' ';
  else {
    sv = '-';
    v = -v;
  }
  w = v;
  if (v == 0.0) {   /*,v:7:1*/
      fprintf(_ars, "%c%7.5f", sv, w);
/*PROB    putc(sv, _ars);*/
    return;
  }
  if (v < 1) {
    if (v >= 0.01) {   /*,v:7:5*/
/*PROB      putc(sv, _ars);*/
      fprintf(_ars, "%c%7.5f", sv, w);
      return;
    }
    do {
      v *= 10;
      n++;
    } while (v < 1);
    k = (long)floor(v * 100 + 0.5);
    if (k == 1000)
      k = 999;
    n--;
    if (n > 0)
      sg = '-';
    fprintf(_ars, "%c.%3d%c%2d", sv, k, sg, n);
    return;
  }
  do {
    v /= 10;
    n++;
  } while (v > 1);
  if (n <= 5) {
    switch (n) {

    case 1:
      fprintf(_ars, "%c%7.5f", sv, w);
      break;

    case 2:
      fprintf(_ars, "%c%7.4f", sv, w);
      break;

    case 3:
      fprintf(_ars, "%c%7.3f", sv, w);
      break;

    case 4:
      fprintf(_ars, "%c%7.2f", sv, w);
      break;

    case 5:
      fprintf(_ars, "%c%7.1f", sv, w);
      break;
    }
    return;
  }
  k = (long)floor(v * 1000 + 0.5);
  if (k == 1000)
    k = 999;
  fprintf(_ars, "%c.%3d%c%2d", sv, k, sg, n);
}

Local Void wr(i, LINK)
short i;
struct LOC_stat *LINK;
{
  /*escribir resultados */
  if (_t != 0.0)
    LINK->_d = (_l2[i-1] - _t * _lp[i-1] * _lp[i-1]) / _t;
  else
    LINK->_d = 0.0;
  if (LINK->_d < 0.0)
    LINK->_d = 0.0;
  else
    LINK->_d = sqrt(LINK->_d);
  if (_en[i-1] > 0)
    LINK->_dp = (_tp2[i-1] - _en[i-1] * _tpp[i-1] * _tpp[i-1]) / _en[i-1];
  else
    LINK->_dp = 0.0;
  if (LINK->_dp < 0.0)
    LINK->_dp = 0.0;
  else
    LINK->_dp = sqrt(LINK->_dp);
  fprintf(_ars, "      %6ld%5ld%6ld", _en[i-1], _l[i-1], _lm[i-1]);
  rncien(_lp[i-1], LINK);
  rncien(LINK->_d, LINK);
  rncien(_mtp[i-1], LINK);
  if (_en[i-1] == 0)
    _tpp[i-1] = 0.0;
  rncien(_tpp[i-1], LINK);
  rncien(LINK->_dp, LINK);

  rncien(_tl[i-1], LINK);
  putc('\n', _ars);   /*add    18/10/96*/
  /*&&*/

  /*writeln(_ars,_tl^[i]:9:1) ;  */
  /*delete 18/10/96*/

  LINK->_cl++;
  if (LINK->_cl < 13)
    return;
  printf("Press any key to continue output table\n");
  _ut = getch();
  LINK->_cl = 2;
  if (!strcmp(_nomars, "CON"))
    _encsal();
}

/* Local variables for _freq: */
struct LOC__freq {
  struct LOC_stat *LINK;
  short mf;
} ;

Local Void hist(h, LINK)
short h;
struct LOC__freq *LINK;
{
  /* escribir linea de histograma */
  Char chg = 220;
  short i;

  h = h * 44 / LINK->mf;   /* escala */
  gotoxy(35, wherey);
  for (i = 1; i <= h; i++)
    putc(chg, _ars);
}

Local Void _freq(LINK)
struct LOC_stat *LINK;
{
  /* escribir tablas de frecuencia */
  struct LOC__freq V;
  /* CARLOS 29.11.2000short i, j, k, fr;
  short tot = 0; */
  int i, j, k, fr;
  int tot = 0;
  short kf;
  double cl, h;
  Char ch1;
  Char STR1[256];

  V.LINK = LINK;
_L2:
  if (_ars != NULL)
    _ars = freopen(_ars_NAME, "a", _ars);
  else
    _ars = fopen(_ars_NAME, "a");
  if (_ars == NULL)
    _EscIO2(FileNotFound, _ars_NAME);
  if (!strcmp(_n_fv[0], "_VFA")) {
    printf("No tables defined\n");
    goto _L1;
  }

  for (j = 1; j <= _n_tab; j++)
    printf("%4d   %s\n", j, _n_fv[j-1]);
  printf("Number of variable? ( 0 for quit ) ");
  scanf("%c%*[^\n]", &ch1);
  getchar();
  sprintf(STR1, "%c", ch1);
  kf = (sscanf(STR1, "%d", &j) == 0);
  if (j <= 0 || kf == 1)
    goto _L1;
  if (j > _n_tab) {
    printf("Variable not tabulated\n");
    goto _L2;
  }
  /*LINUX CLRSCR;*/
  V.mf = -32767;
  k = (long)_df[j-1][1];
  for (i = 0; i <= k - 1; i++) {   /* hallar total y maximo */
    tot += _fr[j-1][i];
    if (_fr[j-1][i] > V.mf)
      V.mf = _fr[j-1][i];
  }
  if (tot != 0) {
    fprintf(_ars, "\nTable %s of variable %s\n\n", _n_ft[j-1], _n_fv[j-1]);
    fprintf(_ars, " Interval         Freq. Rel.Fr. \n\n");
    fr = _fr[j-1][0];
    fprintf(_ars, "      ..<%6.2f%6d%8.3f", _df[j-1][0], fr, (double)fr / tot);
    hist(fr, &V);
    putc('\n', _ars);
    cl = _df[j-1][0];
    h = _df[j-1][2];
    for (i = 1; i <= k - 2; i++) {
      fr = _fr[j-1][i];
      fprintf(_ars, "%6.2f..<%6.2f%6d%8.3f", cl, cl + h, fr, (double)fr / tot);
      hist(fr, &V);
      cl += h;
      putc('\n', _ars);
    }
    fr = _fr[j-1][k-1];
    fprintf(_ars, "       >=%6.2f%6d%8.3f", cl, fr, (double)fr / tot);
    hist(fr, &V);
    fprintf(_ars, "\nTotal          %6d%8.3f\n", tot, 1.000);
    _ch = getch();
    putc('\n', _ars);
    if (_ars != NULL)
      fclose(_ars);
    _ars = NULL;
    goto _L2;
  }
  /* escribir tabla e histograma */
  fprintf(_ars, "No values tabulated\n");
_L1: ;
}


Void stat()
{  /*************** del STAT */
  /*escribir estadisticas*/
  struct LOC_stat V;
  /*escribir datos de nodos */

  /*LINUX var _i,_j,_k,_m,_cl,_r:integer;_vm,_d,_dp,_t1,_rr,_tps:real;*/
  uchar _i, _j, _k, _m, _r;
  double _vm, _t1, _rr, _tps;
  boolean _bd;
  uchar FORLIM;
  Char *TEMP;
  short FORLIM1;
  uchar FORLIM2;

  /*LINUX*/
  GetTime(&_hof, &_mif, &_sef, &_def);
  /*detectar hora final*/
  _intime();   /*calcular duracion simulacion*/
  /*registrar fecha y hora*/
  /*LINUX*/
  GetDate(&_an, &_mes, &_dia, &_diase);
  GetTime(&_ho, &_mini, &_seg, &_s100);
  _bmen = false;
  _t = TIME - _tces;
  FORLIM = _n_list;
  /* actualizar estadisticas de colas */
  for (_i = 0; _i <= FORLIM - 1; _i++) {
    _t1 = TIME - _hc[_i];
    _r = _l[_i];
    _la[_i] += _t1 * _r;
    _l2[_i] += _t1 * _r * _r;
    if (_t != 0)
      _lp[_i] = _la[_i] / _t;
    else
      _lp[_i] = 0.0;
    if (_l[_i] == 0)
      _tl[_i] += _t1;
    /* para est. de espera de encolados revisar cada cola
     la actual estadistica es de los salidos */
    _hc[_i] = TIME;
  }

  /* actualizar estadisticas de variables */
  _aesva();   /* pasar valores actuales a _vas */
  FORLIM = _n_vest;
  for (_m = 0; _m <= FORLIM - 1; _m++) {
    _t2[_m] = TIME - _hcv[_m];
    _sv[_m] += _vas[_m] * _t2[_m];
    _s2v[_m] += _vas[_m] * _vas[_m] * _t2[_m];
    _hcv[_m] = TIME;
  }

  strcpy(_ars_NAME, "/dev/tty");
  if (_ars != NULL)
    _ars = freopen(_ars_NAME, "w", _ars);
  else
    _ars = fopen(_ars_NAME, "w");
  if (_ars == NULL)
    _EscIO2(FileNotFound, _ars_NAME);
  _repi = false;   /*la primera vez no consulta archivo*/

  do {   /* ciclo de estadisticas de colas de nodos mientras Repeat*/
    QUIT1 = false;
    if (_repi) {
/*PROB*/ getchar();
      printf("\nName of output file (CON for Screen):");
      fgets(_nomars, 31, stdin);
      TEMP = strchr(_nomars, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
      FORLIM1 = strlen(_nomars);
      for (_ii = 1; _ii <= FORLIM1; _ii++)
	_nomars[_ii-1] = toupper(_nomars[_ii-1]);
 /*LINUX*/
      if (strcmp(_nomars, "CON") && *_nomars != '\0') { 
        strcpy(_ars_NAME, _nomars);
        if (_ars != NULL) 
	  _ars = freopen(_ars_NAME, "w", _ars); 
        else
	  _ars = fopen(_ars_NAME, "w");
        if (_ars == NULL)
	  _EscIO2(FileNotFound, _ars_NAME);
    }
      else {
 strcpy(_ars_NAME, "/dev/tty");
  if (_ars != NULL)
    _ars = freopen(_ars_NAME, "w", _ars);
  else
    _ars = fopen(_ars_NAME, "w");
  if (_ars == NULL)
    _EscIO2(FileNotFound, _ars_NAME); 
  }
  }
    if (_n_es != 0) {
      _i = 1;
      _encsal();
      V._cl = 2;
      while (_i <= _n_es) {
	fprintf(_ars, "%s\n", _ou[_i-1].nom);
	if (_ou[_i-1].el > 0) {   /* es nodo G L E R O */
	  FORLIM = _ou[_i-1].ind;
	  for (_k = 1; _k <= FORLIM; _k++) {
	    fprintf(_ars, "%4d", _k);
	    fprintf(_ars, " EL");
	    wr(_ou[_i-1].el + _k - 1, &V);
	    if (_ou[_i-1].il > 0) {
	      fprintf(_ars, "     IL");
	      wr(_ou[_i-1].il + _k - 1, &V);
	    }
	    if (_ou[_i-1].il < 0) {   /* es nodo E escribir Tm en syst. */
	      fprintf(_ars, "  Time in System: Mean ");
	      _j = _k - _ou[_i-1].il - 1;
	      V._cl += 2;
	      _rr = _en[_ou[_i-1].el + _k - 2];
	      if (_rr != 0) {
		_tps = _tmps[_j-1] / _rr;
		rncien(_tps, &V);
		V._d = (_t2ps[_j-1] - _rr * _tps * _tps) / _rr;
		if (V._d <= 0)
		  V._d = 0.0;
		else
		  V._d = sqrt(V._d);
		fprintf(_ars, "   Dev. ");
		rncien(V._d, &V);
		fprintf(_ars, "   Max. ");
		rncien(_txps[_j-1], &V);
		fprintf(_ars, "   Min. ");
		rncien(_tips[_j-1], &V);
		putc('\n', _ars);
	      } else
		putc('\n', _ars);
	    }
	  }
	}  /* del if then */
	else {
	  switch (_ou[_i-1].el) {

	  case -2:
	    FORLIM = _ou[_i-1].ind;
	    for (_k = 1; _k <= FORLIM; _k++) {   /*es nodo I */
	      V._cl++;
	      conlin(&V);
	      fprintf(_ars, "%4d # Gen. %7d\n",
		      _k, _nulle[_ou[_i-1].il + _k - 2]);
	    }
	    break;

	  case -1:  /* es nodo D */
	    _j = 1;
	    _bd = true;
	    while (_j <= _ou[_i-1].il && _bd) {
		  /* para los ele.de arr.suc */
		    if (_ou[_i + _j - 1].el == -1)
	      {   /* antecesor L ; una lista por indice del L */
		fprintf(_ars, "     %s\n", _ou[_i + _j - 1].nom);
		    /* nomb. del ant.*/
		V._cl++;
		conlin(&V);
		FORLIM = _ou[_i + _j - 1].ind;
		for (_k = 1; _k <= FORLIM; _k++) {
		  fprintf(_ars, "%7d", _k);
		  wr(_ou[_i + _j - 1].il + _k - 1, &V);
		}
	      } else {
		FORLIM = _ou[_i-1].ind;
		for (_m = 1; _m <= FORLIM; _m++) {
		  V._cl++;
		  conlin(&V);
		  fprintf(_ars, "%4d %s\n", _m, _ou[_i + _j - 1].nom);
		      /*ind.de D nom.suc*/
		  FORLIM2 = _ou[_i + _j - 1].ind;
		  for (_k = 1; _k <= FORLIM2; _k++) {
		    fprintf(_ars, "   %4d", _k);
		    wr(_ou[_i + _j - 1].il + (_m - 1) * _ou[_i + _j - 1].ind +
		       _k - 1, &V);
		  }  /* del for _k */
		}  /* del for _m */
	      }
	      /* antecesor G I R  */
	      /* del else */
	      if (_ou[_i + _j - 1].ind == 1)
		_j++;
	      else
		_bd = false;
	    }  /*del while procesar antecesores*/

	    if (_ou[_i + _j - 1].ind == 1)
	      _i += _ou[_i-1].il;
	    else {
	      _i++;
	      /* adelantar en tabla */

	    }
	    break;
	    /* de procesar nodo D */
	  }/* del case  del else */
	}
	/* es nodo I o D */
	_i++;

      }  /* del while _i */
    }  /* del if nes */
    _ut = getch();

    if (_n_ves != 0) {
      printf("\nPress any key for variables statistics\n");
      _ut = getch();
      _i = 1;
      /*LINUX clrscr;*/
      /* imprimir estadisticas de variables */

      if (!strcmp(_nomars, "CON")) {
	fprintf(_ars, "%s\n", TITLE);
	fprintf(_ars,
		"  Time %10.2f  Time Stat.  %10.2f    Replication   %d\n",
		TIME, _t, NREP);
      } else
	fprintf(_ars, "\n\n");

      fprintf(_ars,
	      "Var/Ind                 Mean(t) Dev.(t)    Max.    Min. ");
      fprintf(_ars, "Mean(v) Dev.(v)  Actual\n");

      V._cl = 2;
      _j = 0;
      while (_i <= _n_ves) {
	FORLIM = _ov[_i-1].ind;
	for (_k = 1; _k <= FORLIM; _k++) {
	  fprintf(_ars, "%12s", _ov[_i-1].nom);
	  fprintf(_ars, "%3d        ", _k);
	  _j++;
	  if (_t != 0) {
	    _vm = _sv[_j-1] / _t;
	    V._d = (_s2v[_j-1] - _t * _vm * _vm) / _t;
	    if (V._d > 0)
	      V._d = sqrt(V._d);
	    else
	      V._d = 0.0;
	  } else {
	    _vm = 0.0;
	    V._d = 0.0;
	  }
	  rncien(_vm, &V);
	  rncien(V._d, &V);
	  if (_hv[_j-1] == -1.7e37)
	    fprintf(_ars, "         ");
	  else
	    rncien(_hv[_j-1], &V);
	  if (_lv[_j-1] == 1.7e37)
	    fprintf(_ars, "         ");
	  else
	    rncien(_lv[_j-1], &V);
	  if (_nvv[_j-1] != 0) {
	    _vm = _svv[_j-1] / _nvv[_j-1];
	    V._d = (_s2vv[_j-1] - _nvv[_j-1] * _vm * _vm) / _nvv[_j-1];
	    if (V._d > 0.0)
	      V._d = sqrt(V._d);
	    else
	      V._d = 0.0;
	  } else {
	    V._d = 0.0;
	    _vm = 0.0;
	  }

	  rncien(_vm, &V);
	  rncien(V._d, &V);
	  rncien(_sva[_j-1], &V);
	  putc('\n', _ars);

	  V._cl++;
	  conlin(&V);
	}
	_i++;
      }
      _ut = getch();
    }  /* del if nves */


    /*MARTA LINUX APPEND(_ARS); */
    putc('\n', _ars);
    if (_ars != NULL)
      fclose(_ars);
    _ars = NULL;   /*TERMINAR ARCHIVO STAT*/
    /*menu de estadisticas*/
    _PREMENUST();
    do {
      MenuS_Retira(&MENUSTAT);
      clrscr();
      switch (SELE) {

      case 1:
	QUIT = true;
	_repi = true;
	break;
	/*REPETIR ESTAD*/

      case 2:
	QUIT = true;
	QUIT1 = true;
	break;
	/*CONTINUAR*/

      case 3:
	_bmen = true;
	QUIT = true;
	QUIT1 = true;
	break;
	/*MENU PRINCIPAL Y CONTINUAR*/

      /*21.04.96*/
      case 4:
	_freq(&V);
	_PREMENUST();
	break;
	/*TABLAS FREC. Y MENUST*/

      /*21.04.96*/
      case 5:
	ggraph();
	_PREMENUST();
	break;
	/*GRAFICO Y MENUST*/
      }
    } while (!QUIT);   /*DE REPETIR MENUST*/
  } while (!QUIT1);   /*DE REPETIR ESTADISTICAS*/
}  /*DEL STAT*/


Void DISFEL(bscr)
boolean bscr;
{
  /* escribir la FEL */
  _fel *_PY;
  Char UT, CH;
  short _CL = 2;

  if (bscr)
    printf("\nFuture Event List at Time%8.3f\n", TIME);
  else
    fprintf(_ftra, "\nFuture Event List at Time%8.3f\n", TIME);
  _PY = _ff;
  if (_PY == NULL) {
    if (bscr)
      printf("Future Event List Void\n");
    else
      fprintf(_ftra, "Future Event List Void\n");
  }
  while (_PY != NULL) {
    if (bscr) {
      printf("NODE %12s     T %8.3f  IND  %4u  EVP    %4d",
	     _nno[_PY->n - 1], _PY->t, _PY->i, _PY->evp);
      if (_PY->su)
	printf("  BLOCKED\n");
      else
	putchar('\n');
    } else {
      fprintf(_ftra, "NODE %12s     T %8.3f  IND  %4u  EVP    %4d",
	      _nno[_PY->n - 1], _PY->t, _PY->i, _PY->evp);
      if (_PY->su)
	fprintf(_ftra, "  BLOCKED\n");
      else {
	putc('\n', _ftra);
	/*1998*/
      }
    }

    _PY = _PY->p;
    _CL++;
    if (_CL <= 16)
      continue;
    printf("Press any key to continue ");
    CH = getch();
    clrscr();
    _CL = 2;
    putchar('\n');
  }
  UT = getch();
  if (bscr)
    putchar('\n');
  else
    putc('\n', _ftra);
}


/************************************************_PREMENU***/
Static Void _PREMENU()
{
  /*preparar menu de entrada / salida*/
  clrscr();
  _bmen = false;   /*BLACK,WHITE*/
  /*TEXTCOLOR(yellow); TEXTBACKGROUND(blue);*/
  Ventana_MainPort(&VPRINCIPAL, Blue, Yellow);
  MenuS_Init(&MENUENSAL, 6, 6, 24, 26, 7, Cyan, White);
  MenuS_DefiOpcios(&MENUENSAL, CMENUENSAL);
  QUIT = false;
  do {
    SELE = MenuS_Selec(&MENUENSAL);
  } while (SELE <= 0);
  _bt = false;
  NREP = 1;

}


/***********************************************************_MENU****/
Void _menu()
{
  /*Menu de entrada y salida*/
  double t;
  Char *TEMP;

  _bmen = false;
  if (_prm)
    NREP = 1;
  strcpy(_nomars, "CON");
  strcpy(TITLE, " ");
  if ((_prm || !_rep) && _bout) {   /*no es disen~o Y ES PRIMERA VEZ */
    _PREMENU();
    do {
      MenuS_Retira(&MENUENSAL);
      switch (SELE) {

      case 6:
	QUIT = true;
	_ut = 'Q';
	break;
	/*QUIT Y SALIR*/

      case 2:  /*TITLE Y VOLVER A MENU*/
	gotoxy(24, 20);
	printf("Title up to 80 characters\n");
	fgets(TITLE, 81, stdin);
	TEMP = strchr(TITLE, '\n');
	if (TEMP != NULL)
	  *TEMP = 0;
	_ut = 'I';
	_PREMENU();
	break;

      case 1:
	_ut = 'I';
	_inici();
	QUIT = true;   /*INIT Y SALIR*/
	break;

      case 3:  /*REPLIC Y SALIR*/
	NREP = 0;
	gotoxy(16, 16);
	printf("Number of Replications              ");
	scanf("%hd%*[^\n]", &NTREP);
	getchar();
	if (NTREP < 1)
	  _Escape(0);
	gotoxy(16, 18);
	printf("Statistics each replication Yes/No  ");
	_ch = toupper(getch());
	if (_ch == 'Y')   /*or (_ch='y')*/
	  _est = true;
	else
	  _est = false;
	/*inicializar semillas de numeros aleatorios*/
	inisem();
	_inieli();
	_com();
	_rep = true;
	clrstat();
	/*LINUX*/
	_ginit();
	QUIT = true;
	/*inicializar pantalla, puede ir en INIT!!!*/
	break;

      case 5:  /*TIEMPO ADICIONAL Y SALIR*/
	if (_es) {
	  printf("A option with ENDSIMUL illegal\n");
	  _ch = getch();
	  _PREMENU();
	} else {
	  printf("Aditional time : ");
	  scanf("%lg%*[^\n]", &t);
	  getchar();
	  tsim += t;
	  if (_bgr == true) {
	    _bgr = false;
	    _gr = true;
	    _bpg = true;
	  }
	}
	QUIT = true;
	break;

      case 4:  /*GRAFICO Y VOLVER A MENU*/
	ggraph();
	_PREMENU();
	break;
	/*GGRAPHIC*/

      }/*del case*/

    } while (!QUIT);
    /*LINUX CLRSCR;*/
    /*SI NO ES DE SALIDA Y NO ES OPCION QUIT */

    if (_prm && SELE != 6 || SELE == 1) {   /*LLAMAR MENU PRINCIPAL*/
      menu();

      /*LINUX*/
      getch();   /*BLUE,YELLOW*/
      Ventana_MenuPort(&VPRINCIPAL, 20, 10, 34, 1, LightGray, Black);
      /*LINUX GOTOXY(3,4); write('T for Trace/ C to Continue ');
      GOTOXY(3,2); write('During Execution press  M  for Menu');*/
      gotoxy(22, 11);
      printf("During Execution press  M  for Menu");
      gotoxy(22, 13);
      printf("T for Trace/ C to Continue ");
      _ch = toupper(getch());   /*BLACK,WHITE*/
      Ventana_MainPort(&VPRINCIPAL, Blue, Yellow);

      clrscr();
      if (_ch == 'T')
	initra();
    }
    gotoxy(1, 15);
    return;
  }
  /*y no es sal.suprimida*/


  if (_rep || _bout)   /*si no es rep. ni supr. de output*/
    return;
  inisem();   /*inicializar semillas num.aleat*/
  _inieli();   /*crear listas en memoria dinamica*/
  _com();
  clrstat();
  /*LINUX*/
  _ginit();
  /*disen~o de experimentos o repeticion o supr. de output*/
}


/***************************************************PREMENU*********/
Static Void PREMENU()
{
  /*preparar menu de principal (de ejecucion)  */
  clrscr();
  /*TEXTCOLOR(yellow); TEXTBACKGROUND(blue);*/
  Ventana_MainPort(&VPRINCIPAL, Black, White);
  MenuS_Init(&MENUPRIN, 9, 9, 44, 16, 7, Cyan, White);
  MenuS_DefiOpcios(&MENUPRIN, CMENUPRIN);

  QUIT = false;

  do {
    SELE = MenuS_Selec(&MENUPRIN);
  } while (SELE <= 0);
  _bt = false;
  NREP = 1;
}


/******************************************************MENU****/
Void menu()
{
  /*menu principal  o de ejecucion*/
  _bmen = false;
  if (_bgr == true)   /*quitar modo grafico*/
    CloseGraph();
  _bt = false;
  _quit = false;
  PREMENU();
  do {
    MenuS_Retira(&MENUPRIN);
    switch (SELE) {

    case 9:
      QUIT = true;
      _quit = true;
      _ut = 'Q';
      break;

    case 3:
      _pexp();
      _ch = getch();
      PREMENU();
      break;

    case 2:
      clrstat();
      QUIT = true;
      break;

    case 1:
      _ut = 'I';
      QUIT = true;
      break;

    case 5:
      DISFEL(true);
      PREMENU();
      break;

    case 6:
      printf("Display or Skip statistics ");
      _ch = toupper(getch());
      if (_ch == 'D')
	_est = true;
      else
	_est = false;
      QUIT = true;
      break;

    case 7:
      initra();
      QUIT = true;
      break;

    case 4:
      stat();
      QUIT = true;
      break;

    case 8:
      ggraph();
      PREMENU();
      break;
    }
  } while (!QUIT);
  /*marta textbackground(blue); textcolor(yellow); */
  clrscr();   /* y por si hay grafico: */

  if (_bgr != true)
    return;

  _bgr = false;
  _gr = true;
  _bpg = true;
}


/*******************************************************REPLIC**/
Void replic()
{
  /*hacer replicacion conservar num.aleat.*/
  NREP++;
  _com();
  /*LINUX*/
  _ginit();
  clrstat();
}


/*********************************************************TRACE****/
Void _trace()
{
  /*ve si hay que poner o quitar trace y llama menu*/
  if (!_bt && kbhit()) {
    _u = toupper(getch());
    if (_u == 'T') {
      clrscr();
      gotoxy(1, 2);
      initra();
      _u = ' ';
    }
    if (_u == 'M') {
      menu();
      clrscr();
    }
  }
  if (_bt && toupper(_u) == 'T') {
    _u = toupper(getch());
    if (_u == 'T') {
      clrscr();
      _bt = false;
      menu();
    }
  }
  if (_bt && toupper(_u) == 'M')
    menu();
}


/********************************************************_EXFEL***/
Void _exfel()
{
  /* extr. primero activo de fel */
  _fel *ff, *fa;
  uchar X, Y;   /*ff: extraido; fa: anterior*/

  if (_ff == NULL) {
    printf("Empty FEL. Press any key to menu\n");
    _ch = getch();
    menu();
    _Escape(0);
  }

  ff = _ff;
  fa = ff;   /*buscar primer no suspendido; lo apuntara ff*/
  while (ff->su) {
    fa = ff;
    ff = ff->p;
  }  /*fa anterior a ff*/

  if (ff->t >= TIME)   /*actualizar TIME*/
    TIME = ff->t;
  /*si ff fue suspendido puede tener t<time; dejar el TIME actual*/
  /*pasar los parametros*/
  _n = ff->n;
  iev = ff->i;
  evp = ff->evp;
  _tev = ff->t;   /*tiempo del evento; puede estar retrasado*/
  if (_ff == ff)
    _ff = _ff->p;   /*no hay susp. _ff apunta al siguiente*/
  else
    fa->p = ff->p;
  /*hay, quitar el ap. por ff de la lista; _ff igual*/

  Free(ff);

  if (_bt) {  /*disfel(true);*/
    printf(
      "EVENT  %3u  IEV %3d  ********************>>>>>>>>>>>>>>        TIME %9.3f\n",
      _n, iev, TIME);
    _ch = getch();

    if (_bftr)  /*disfel(false);*/
      fprintf(_ftra,
	"EVENT  %3u  IEV %3d  ******************>>>>>>>>>>>>>>          TIME %9.3f\n",
	_n, iev, TIME);
  }

  if (_bt)
    return;
/*PROB
  X = wherex;
  Y = wherey;*/
  gotoxy(1, 1);
  printf("    RUNNING               TIME %10.2f    REPL %4d\n", TIME, NREP);
  /*gotoxy(X, Y); */
}


/********************************************************EXTFEL***/
Void extfel(iev, t, ino, evp)
short iev;
double t;
short ino;
uchar evp;
{
  /*extr.de FEL el de time t */
  _fel *_pf, *_py;

  _pf = _ff;
  if (t >= 0.0) {
    _bo = true;
    while (_pf != NULL && _bo) {
      if (t == _pf->t && (iev == 0 || iev == _pf->n) &&
	  (ino == 0 || ino == _pf->i) && (evp == 0 || evp == _pf->evp))
	_bo = false;
      else {
	_py = _pf;
	_pf = _pf->p;
      }
    }
    if (_pf == NULL)
      printf("extr.from fel (t) not possible\n");
    goto _L1;   /*quitar!!!!!*/
  }
  /*t<0 busca por iev, ino o evp Poner else!!!!!*/
  if (iev != 0) {
    _bo = true;
    while (_pf != NULL && _bo) {
      if (iev == _pf->n)
	_bo = false;
      else {
	_py = _pf;
	_pf = _pf->p;
      }
    }
    if (_pf == NULL)
      printf("extr.from fel (iev) not possible\n");
  }

  if (ino != 0) {
    _bo = true;
    while (_pf != NULL && _bo) {
      if (ino == _pf->i)
	_bo = false;
      else {
	_py = _pf;
	_pf = _pf->p;
      }
    }
    if (_pf == NULL)
      printf("extr.from fel (ino) not possible\n");
  }

  if (evp != 0) {
    _bo = true;
    while (_pf != NULL && _bo) {
      if (evp == _pf->evp)
	_bo = false;
      else {
	_py = _pf;
	_pf = _pf->p;
      }
    }
    if (_pf == NULL)
      printf("extr.from fel (evp) not possible\n");
  }

_L1:
  if (_ff == _pf)
    _ff = _pf->p;
  else
    _py->p = _pf->p;

  if (!_bt)
    return;

  /**************dispose(_pf);  ************************/
  printf("DELETED FROM FEL EVENT %u  TIME %8.2f  EVP %d  IEV %u",
	 _pf->n, _pf->t, _pf->evp, _pf->i);
  gotoxy(64, wherey);
  printf("TIME %9.3f\n", TIME);
  _ch = getch();
  if (_bftr) {
    fprintf(_ftra, "DELETED FROM FEL EVENT %u  TIME %8.2f  EVP %d  IEV %u",
	    _pf->n, _pf->t, _pf->evp, _pf->i);
    fprintf(_ftra, "%sTIME %9.3f\n", _c08, TIME);
  }
}


/*********************************************************PUTFEL***/
Void putfel(ab, i, h, ind, par)
Char ab;
short i;
double h;
short ind;
uchar par;
{
  _fel *_pf, *_py, *_pa;
  boolean bb;

  /*WRITELN('ENTRADA A PUTFEL DE HORA ',H:8:2); _CH:=READKEY; */
  _py = (_fel *)Malloc(sizeof(_fel));
  /************** ver _afel
   buscar nombre en tabla y sacar el numero i ***/

  _py->n = i;
  _py->t = h;
  _py->i = ind;
  _py->evp = par;
  _py->p = NULL;

  if (_ff == NULL)   /*si la FEL esta vacia*/
    _ff = _py;   /*poner primero y unico*/
  else {
    _pf = _ff;
    _pa = _ff;
    bb = true;
    while (_pf != NULL && bb) {   /*apuntar mayor y antecesor*/
      /* WRITELN('REVISA EL ',_PF^.N,'  HORA ',_PF^.T:8:2); _CH:=READKEY;*/
      switch (ab) {

      case 'A':
	if (_pf->t <= h) {
	  _pa = _pf;
	  _pf = _pf->p;
	} else
	  bb = false;
	break;

      case 'B':
	if (_pf->t < h) {
	  _pa = _pf;
	  _pf = _pf->p;
	} else
	  bb = false;
	break;
      }
    }
    if (_pf == _ff)
      _ff = _py;   /*anterior al primero*/
    else
      _pa->p = _py;
    /*sigue al anterior*/
    if (_pf != NULL)   /*si no es ultimo, precede al mayor*/
      _py->p = _pf;
  }
  if (!_bt)
    return;
  printf("ADD TO FEL EV %d IEV %d EVENT TIME %9.3f\n", i, ind, h);
  if (_bftr)
    fprintf(_ftra, "ADD TO FEL EV %d IEV %d EVENT TIME %9.3f\n", i, ind, h);
}


/********************************************************_ACT***/
Void _act(m, b)
short m;
boolean b;
{
  /* actual.estadisticas lista m */
  double tt, t, r, d;

  t = TIME - _hc[m-1];
  r = _l[m-1];
  _la[m-1] += t * r;
  _l2[m-1] += t * r * r;
  tt = TIME - _tces;

  /*largo medio de lista m  y su desviacion*/
  if (tt != 0)
    _lp[m-1] = _la[m-1] / (TIME - _tces);
  else
    _lp[m-1] = 0.0;
  if (tt != 0.0)
    d = (_l2[m-1] - tt * _lp[m-1] * _lp[m-1]) / tt;
  else
    d = 0.0;
  if (d <= 0.0)
    _de[m-1] = 0.0;
  else
    _de[m-1] = sqrt(d);

  /*actualizar largo maximo lista m*/
  if (b && _l[m-1] >= _lm[m-1])
    _lm[m-1] = _l[m-1] + 1;

  if (_l[m-1] == 0)   /*tiempo libre*/
    _tl[m-1] += t;

  if (_en[m-1] > 0)   /*tiempo permanencia media en lista m y su desviacion*/
    _tpp[m-1] = _tp[m-1] / _en[m-1];
  else
    _tpp[m-1] = 0.0;
  if (_en[m-1] > 0)
    d = (_tp2[m-1] - _en[m-1] * _tpp[m-1] * _tpp[m-1]) / _en[m-1];
  else
    d = 0.0;
  if (d <= 0.0)
    _dp[m-1] = 0.0;
  else
    _dp[m-1] = sqrt(d);

  _hc[m-1] = TIME;   /*hora ultimo cambio en lista m */
}


/**********************************************************_AGR***/
Void _agr(m, q, p)
short m;
_rl *q;
Char p;
{
  /* agreg.el apuntado por _pl, a listai m, posi.p ;
     pone nil si es ultimo; ajusta ET a TIME; ajusta lm y en*/
  _fg *pt;

  _swt = false;
  if (_fl[m-1] == NULL) {
    _fl[m-1] = q;
    _ll[m-1] = q;
    q->p = NULL;
  } else {
    switch (p) {

    case 'l':
      _ll[m-1]->p = q;
      q->p = NULL;
      _ll[m-1] = q;
      break;

    case 'f':
      q->p = _fl[m-1];
      _fl[m-1] = q;
      break;
    }
  }
  _act(m, true);
  /*LINUX pt:=...(q^.b,q^.d);*/
  pt = (_fg *)q->b;
  pt->et = TIME;
  et = TIME;
  if (_bt) {
    printf("ADD MESS.#%5u GEN %12s TO   %15s LL %5ld TIME %9.3f\n",
	   q->number, q->NOR, _tnl[m-1], _l[m-1], TIME);
    if (_bftr)
      fprintf(_ftra, "ADD MESS.#%5u GEN %12s TO   %15s LL %5ld TIME %9.3f\n",
	      q->number, q->NOR, _tnl[m-1], _l[m-1], TIME);
    _ch = getch();
  }
  _l[m-1]++;
  _en[m-1]++;
  if (_bt)
    printf("%ld *****XXXX*************\n", _en[m-1]);
}


/*****************************************************_INTER**/
Void _inter(m, _px, _pa, _pu)
short m;
_rl *_px, *_pa, *_pu;
{
  /* intercalar el apuntado por _px de lista m entre  _pa,,_pu */
  /*_pa o _pu pueden ser nil*/
  _fg *pt;

  if (_pa == NULL)
    _fl[m-1] = _px;
  else
    _pa->p = _px;
  _px->p = _pu;
  /*LINUX pt:=...(_px^.b,_px^.d); pt^.ET:=time;*/
  pt = (_fg *)_px->b;
  pt->et = TIME;
  if (_bt) {
    printf("INT.MESS.#%5u GEN %12s TO %15s LENGTH %5ld TIME %9.3f\n",
	   _px->number, NODE, _tnl[m-1], _l[m-1], TIME);
    if (_bftr)
      fprintf(_ftra,
	      "INT.MESS.#%5u GEN %12s TO %15s LENGTH %5ld TIME %9.3f\n",
	      _px->number, NODE, _tnl[m-1], _l[m-1], TIME);
    _ch = getch();
  }
  _act(m, true);
  _l[m-1]++;
  _en[m-1]++;
}


/*********************************************************_EXAL**/
Void _exal(q)
_rl *q;
{
  /* exam. de listai ap.por q;apun.p al sig.*/
  _fg *pt;

  if (q == NULL) {   /*MEN10/4/1998*/
    _error_("examined messages list empty");
    return;
  }
  _r = q->r;
  _b = q->b;
  _d = q->d;
  /*LINUX pt:=...(_b,_d); ET:=pt^.et; XT:=pt^.xt;*/
  pt = (_fg *)_b;
  et = pt->et;
  xt = pt->xt;
  _p = q->p;
  NUMBER = q->number;
  strcpy(NODE, q->NOR);   /*para el uso del usuario*/
  if (!_bt)
    return;
  printf("EXA.MESS.#%5u GEN %12s\n", q->number, q->NOR);
  if (_bftr)
    fprintf(_ftra, "EXA.MESS.#%5u GEN %12s\n", q->number, q->NOR);
  _ch = getch();
}


/*******************************************************_EXALO**/
Void _exalo(q)
_rl *q;
{
  /* exam. de listai ap.por q;apun.p al sig.*/
  _fg *pt;

  if (q == NULL) {   /*MEN*10/4/1998*/
    _error_("examined O_messages list empty");
    return;
  }
  _or = q->r;
  _ob = q->b;
  _od = q->d;
  /*LINUX pt:=...(_ob,_od); O_ET:=pt^.et; O_XT:=pt^.xt;*/
  pt = (_fg *)_ob;
  o_et = pt->et;
  o_xt = pt->xt;
  O_NUMBER = q->number;
  strcpy(O_NODE, q->NOR);   /*para el uso del usuario*/
  /*anterior agregada 05071996*/
  _op = q->p;
}


/*******************************************************_EXTR***/
Void _extr(q, m)
_rl **q;
short m;
{
  /* extr.de listai m,ap.por q */
  _fg *pt;
  double tx;
  _rl *_t;

  _swt = false;
  /*LINUX pt:=...(q^.b,q^.d);*/
  /*apuntador al que se va a extraer*/
  /*com 1998*/
  pt = (_fg *)(*q)->b;   /*apuntador al que se va a extraer*/
  /*com 1998*/
  NUMBER = (*q)->number;
  strcpy(NODE, (*q)->NOR);   /*para uso del usuario*/

  if (_bt) {   /*si hay trace*/
    printf("EXT.MESS.#%5u GEN %12s FROM %15s LL %5ld TIME %9.3f\n",
	   (*q)->number, (*q)->NOR, _tnl[m-1], _l[m-1], TIME);
    if (_bftr)
      fprintf(_ftra, "EXT.MESS.#%5u GEN %12s FROM %15s LL %5ld TIME %9.3f\n",
	      (*q)->number, (*q)->NOR, _tnl[m-1], _l[m-1], TIME);
    _ch = getch();
  }
  if (_fl[m-1] == NULL)   /*MEN10/4/1998*/
    _error_("list to extract empty");
  if (_fl[m-1]->p == NULL) {   /* hay uno solo; guardar cabeza en q (var) */
    *q = _fl[m-1];
    _fl[m-1] = NULL;
    _ll[m-1] = NULL;
  }  /*apun. a cabeza y cola a nil*/
  /*hay varios*/
  /*com 1998*/
  else if (*q == _fl[m-1]) {
    _fl[m-1] = (*q)->p;
    /* es el primero de varios
                                         la cabeza apunta al siguiente*/
  } else {
    _t = _fl[m-1];   /*apuntar primero por t*/
    while (_t != *q) {
      _pa = _t;
      _t = _t->p;
      if (_t == NULL)
	_error_("no message to send");
    }
    _pa->p = _t->p;
    /*el anterior apuntara al sig.
                     del q, si este es ultimo queda nil*/
    if (*q == _ll[m-1]) {   /*por si era ultimo*/
      _ll[m-1] = _pa;
      /* si no, hay que buscar el anterior */
    }
  }

  _act(m, false);
  _l[m-1]--;
  tx = TIME - pt->et;
  _tp[m-1] += tx;
  _tp2[m-1] += tx * tx;
  if (tx > _mtp[m-1])
    _mtp[m-1] = tx;
}


/******************************************************_TRAN**/
Void _tran(bex, m, n, p, apor, apde)
boolean bex;
short m, n;
Char p;
_rl *apor, *apde;
{
  /* extrae el de lista m apuntado por apor (si bex true) y pone en
pos. p de lista n apuntado por apde
Si se indica extraer y es m=0 se trata de lista de ensamblados
y es necesario hacer la extraccion aparte*/
  _rl *pac, *pan, *pg, *pa, *apor1;
  _fg *pt;

  /*extraer un ensamblado*/
  if (m == 0 && bex)   /*lista de ensamblados. Extraer el ap. por _pu*/
  {  /*poner apor en vez de _pu*/
    pg = _px->pas;   /*desde _px.pas buscar anterior al apunt. por _pu */
    pa = pg;
    while (pg != _pu) {
      pa = pg;
      pg = pg->p;
    }
    if (pg == _px->pas) {
      _px->pas = pg->p;
      _pas = pg->p;
    }  /*si ES EL PRIMERO*/
    else {
      pa->p = _pu->p;
      _pas = pa->p;
    }
    /*conec anterior al sig*/

    if (_bt) {   /*trazado*/
      /*LINUX pt:=...(_pu^.b,_pu^.d);*/
      pt = (_fg *)_pu->b;
      printf("EXT.MESS. GT %9.2f  FROM ASSEMBLE LIST", pt->gt);
      gotoxy(65, wherey);
      printf("TIME %9.2f\n", TIME);
      if (_bftr) {
	fprintf(_ftra, "EXT.MESS. GT %9.2f  FROM ASSEMBLE LIST", pt->gt);
	fprintf(_ftra, "%sTIME %9.2f\n", _c08, TIME);
      }
      _ch = getch();
    }
    /*falta enviar el extraido a su destino*/
  }  /*fin de envio de ensamblado*/


  if (bex && m != 0)   /*hay que extraer de lista EL o IL*/
  {  /*1998*/
    apor1 = apor->p;   /*guardar apuntador al sig.del que se va a extraer*/
    _extr(&apor, m);   /* extraer del origen:apor,lista m; act.estad.*/
    /*apor queda apuntando al extraido, pero*/

    if (_bsc) {
      /*MARTA*/
      _pu = apor1;   /*1998*/
      /*si es SCAN o EXTR apuntar
                                 _pu al que sigue*/

      if (_pu != NULL)   /*9/4/1998*/
      {  /*pasar variables del siguiente a O_variables */
	/*LINUX _uprvo(_pu^.r,_pu^.b,_pu^.d);*/
	/*9/4/1998*/
	_uprvo(_pu->r, _pu->b);   /*9/4/1998*/
	O_PMESS = _pu;   /*9/4/1998*/
	_exalo(_pu);   /*9/4/1998*/
      }

    }

  }

  /*agregado del extraido o del apuntado por apor*/

  if (_fl[n-1] == apde && p == 'B') {   /*agregar antes que el primero*/
    if (_bt)
      printf("ANTES %ld\n", _en[n-1]);
    _agr(n, apor, 'f');   /* agregar comienzo act.estad*/
    if (_bt)
      printf("DESPUES %ld\n", _en[n-1]);

    if (!(bex && apor != NULL && apor->p != NULL)) {
	  /*si se extrajo y se agrego y hay sig.*/
	    /*agregar despues del ultimo*/
	    return;
    }
    /*****************SE SUPONE _PU<>_PX***********/
    if (apor == _px)
      _px = apor1;
    else if (apor == _pu)
      _pu = apor1;
    return;
  }

  /*apunt.sig.al extr*/
  if (_ll[n-1] == apde && p == 'A') {   /*agregar despues del ultimo*/
    _agr(n, apor, 'l');   /* agregar final act.estad*/
    return;
  }

  if (p == 'A') {   /*agregar despues del apuntado*/
    apor->p = apde->p;
    apde->p = apor;
  } else {
    pac = _fl[n-1];
    pan = pac;
    while (pac != NULL && pac != apde) {
      pan = pac;
      pac = pac->p;
    }
    apor->p = pan->p;
    pan->p = apor;
  }
  /*p='B' agregar antes del apuntado*/

  _swt = false;

  /*LINUX pt:=...(apor^.b,apor^.d);*/
  pt = (_fg *)apor->b;
  if (_bt) {
    printf("ADD MESS.#%5u GEN %12s TO   %15s LL %5ld TIME %9.3f\n",
	   apor->number, apor->NOR, _tnl[n-1], _l[n-1], TIME);

    if (_bftr)
      fprintf(_ftra, "ADD MESS.#%5u GEN %12s TO   %15s LL %5ld TIME %9.3f\n",
	      apor->number, apor->NOR, _tnl[n-1], _l[n-1], TIME);
    /**/
    _ch = getch();
  }

  _act(n, true);
  pt->et = TIME;
  et = TIME;   /*actualiza tiempo de entrada*/
  _l[n-1]++;
  _en[n-1]++;
  /*apde es un apuntador*/


}


/****************************************************_EXLX*************/
Void _exlx(q, m)
_rl **q;
short m;
{
  /*busca en IL de nodo R*/
  _rl *p;
  _fg *pt;

  if (_bt) {
    printf("EXAM.LIST %s SEEK EXIT TIME %9.3f\n", _tnl[m-1], _tev);
    if (_bftr)
      fprintf(_ftra, "EXAM.LIST %s SEEK EXIT TIME %9.3f\n", _tnl[m-1], _tev);
    _ch = getch();
  }
  *q = _fl[m-1];
  _bo = true;
  while (*q != NULL && _bo) {
    /*LINUX begin pt:=...(q^.b,q^.d);*/
    pt = (_fg *)(*q)->b;
    if (pt->xt == _tev)
      _bo = false;
    p = *q;
    *q = (*q)->p;
  }
  *q = p;
  if (_bo)
    _error_("no register with EX=time");
}


/********************************************* _COPY******/
Void _copy(p, m, aob, apdes)
_rl *p;
short m;
Char aob;
_rl *apdes;
{
  /*_copy(p:_pl;m:integer);*/
  /* copia reg.e indic. y env. a m AoB apdes*/
  /*LINUX begin _newr(p^.r,_b,_d); new(_pp); _pp^.r:=p^.r;*/
  _newr(p->r, &_b);
  _pp = (_rl *)Malloc(sizeof(_rl));
  _pp->r = p->r;
  _pp->b = _b;
  _pp->d = _d;
  _pp->number = p->number;
  strcpy(_pp->NOR, p->NOR);
  /*_agr(m,_pp,'l')*/
  _tran(false, 0, m, aob, _pp, apdes);
}


/******************************************************_SINC***/
Void _sinc(m, n)
short m, n;
{
  /* hace lista sincr.por cond.log.n  */
  /* busca hasta m o nil              */
  if (_bt) {
    printf("SEEK TO SYNCHRO %d WITH CONDITION %d\n", m, n);
    if (_bftr)
      fprintf(_ftra, "SEEK TO SYNCHRO %d WITH CONDITION %d\n", m, n);
  }

  /*LINUX _exal(_pu); _uprv(_r,_b,_d);*/
  _exal(_pu);
  _uprv(_r, _b);
  _ks = 1;
  _fs = (_res *)Malloc(sizeof(_res));
  _fs->p1 = _pu;
  _fs->p2 = NULL;
  _as = _fs;
  _psi = _pu->p;   /* _psi apunta a primero a comparar */
  while (_psi != NULL && _ks < m) {
    _exalo(_psi);
    /*LINUX _uprvo(_or,_ob,_od);*/
    _uprvo(_or, _ob);
    if (_cl(n)) {   /* ver condicion logica n */
      _pc = (_res *)Malloc(sizeof(_res));
      _pc->p1 = _psi;
      _ks++;
      _pc->p2 = NULL;
      _as->p2 = _pc;
      _as = _pc;
    }
    _psi = _psi->p;   /* ir a comparar con el siguiente */
  }
  _sf = true;
  if (!_bt)
    return;
  printf("%d RECORDS SYNCHRONIZED\n", _ks);
  if (_bftr)
    fprintf(_ftra, "%d RECORDS SYNCHRONIZED\n", _ks);
}


/*****************************************************TAB******/
Void tab(x, j)
double x;
short j;
{
  /*suma 1 al inter.de clase,  tabl. j */
  double cl;
  boolean b = true;
  short i = 1;
  short k;

  cl = _df[j-1][0];
  k = (long)_df[j-1][1];
  while (b && i < k) {
    if (x < cl)
      b = false;
    else {
      cl += _df[j-1][2];
      i++;
    }
  }
  _fr[j-1][i-1]++;
}


/****************************************************_EUL***/
Void _eul(m, n)
short m, n;
{
  /*Euler*/
  short iec;
  _arrv _a;

  for (iec = m; iec <= n; iec++)
    _a[iec - m] = _dt * _fec(TIME, iec);
  for (iec = m; iec <= n; iec++)
    _y[_ore[iec-1] - 1] += _a[iec - m];
}


/*******************************************************_RK4**/
Void _rk4(m, n)
short m, n;
{
  /*Runge-Kutta de orden 4, paso fijo*/
  _arrm a;
  short i, iec, iea;
  _arrv z;

  static double c[3] = {
    0.5, 0.5, 1.0
  };

  static double dti[3] = {
    0.5, 0.5, 1.0
  };

  /*FOR IEC:=M TO N DO
WRITELN('INICIA CALCULO CON VALOR ',IEC,_Y[_ORE[IEC]]:8:2);
WRITELN('M ',M,'   N ',N); CH:=READKEY;  */
  for (iec = m - 1; iec <= n - 1; iec++)
    z[_ore[iec] - 1] = _y[_ore[iec] - 1];
  /*guar.en z val.inic.de var a cambiar*/

  for (iec = m; iec <= n; iec++)
    a[0][iec - m] = _dt * _fec(TIME, iec);

  for (i = 2; i <= 4; i++) {   /*calcular a[2,iec-m+1] a[3,iec-m+1], etc*/
    for (iec = m - 1; iec <= n - 1; iec++)
	  /*val. inic.-> a las var.a cambiar*/
	    _y[_ore[iec] - 1] = z[_ore[iec] - 1];

    for (iec = m; iec <= n; iec++)
      _y[_ore[iec-1] - 1] += a[i-2][iec - m] * c[i-2];
    for (iec = m; iec <= n; iec++)
      a[i-1][iec - m] = _dt * _fec(TIME + dti[i-2] * _dt, iec);
  }

  for (iec = m; iec <= n; iec++) {
    iea = iec - m + 1;
    _y[_ore[iec-1] - 1] = z[_ore[iec-1] - 1] + (a[0]
	    [iea-1] + 2.0 * a[1][iea-1] + 2.0 * a[2][iea-1] + a[3]
	    [iea-1]) / 6.0;
  }

}


/******************************************************_RKF**/
Void _rkf(m, n)
short m, n;
{
  /*Runge-Kutta-Fehlberg*/
  _arrm a;
  short i, j, k, iec, iecm, iea;
  _arrv z, error;
  double err, q, ym;
  boolean cont;

  static double c[15] = {
    0.25, 0.09375, 0.28125, 0.8793809, -3.2771962, 3.3208921, 2.0324074, -8.0,
    7.1734893, -0.2058966, -0.296296296, 2.0, -1.3816764, 0.4529727, -0.275
  };

  static double dti[6] = {
    0.0, 0.25, 0.375, 0.9230769, 1.0, 0.5
  };

  /*FOR IEC:=M TO N DO
WRITELN('INICIA CALCULO CON VALOR ',IEC,_Y[_ORE[IEC]]:8:2);
   */
/*PROB   printf("_rkf m: %d n: %d \n",m,n); getchar();*/

  for (iec = m - 1; iec <= n - 1; iec++)
    z[_ore[iec] - 1] = _y[_ore[iec] - 1];
  /*guar.en z val.inic.de var a cambiar*/

  do {   /* repetir hasta error maximo del paso <errp */
    cont = true;
    for (iec = m; iec <= n; iec++)
      a[0][iec - m] = _dt * _fec(TIME, iec);
    k = 0;
    for (i = 1; i <= 6; i++) {
      k += i - 2;
      for (iec = m - 1; iec <= n - 1; iec++)
	    /*val. inic.-> a las var.a cambiar*/
	      _y[_ore[iec] - 1] = z[_ore[iec] - 1];
      for (j = 2; j <= i; j++) {
	for (iec = m; iec <= n; iec++)
	  _y[_ore[iec-1] - 1] += a[j-2][iec - m] * c[j + k - 1];
      }
      for (iec = m; iec <= n; iec++)
	a[i-1][iec - m] = _dt * _fec(TIME + dti[i-1] * _dt, iec);
    }

    err = 0.0;   /******!!!!!!!!REVISAR****************/
    for (iec = m + 1; iec <= n + 1; iec++) {
      iea = iec - m;
      error[iea-1] =
	0.002777777 * a[0][iea-1] - 0.0299415 * a[2][iea-1] - 0.0291998 * a[3]
	  [iea-1] + 0.02 * a[4][iea-1] + 0.036363636 * a[5][iea-1];
      if (fabs(error[iea-1]) >= err) {
	err = fabs(error[iea-1]);
	iecm = iea;
      }
    }

    ym = _y[_ore[iecm-1] - 1] + 0.1157407 * a[0][iecm-1] + 0.5489278 * a[2]
	   [iecm-1] + 0.5353313 * a[3][iecm-1] - 0.2 * a[4][iecm-1];
    q = err / (eabs + erel * fabs(ym)) + 1;
    if (q > 1.1) {
      _dt /= sqrt(sqrt(q));
      cont = false;
      /*  write(' q=',q:7:2,' dism.');write(' nuevo  _dt=',_dt:14:10); */
      for (iec = m - 1; iec <= n - 1; iec++)
	    /*val. inic.-> a las var.a cambiar*/
	      _y[_ore[iec] - 1] = z[_ore[iec] - 1];
    }
    if (q < 0.5) {   /*OJO SE PUSO /  EN VEZ DE *  */
      _dt /= sqrt(sqrt(q));   /*write(' q=',q:7:2,' aume. '); */
      /*  write('    nuevo  _dt=',_dt:14:10);*/
      _dta = _dt;
    }

    /*writeln;  */
  } while (!cont);

  for (iec = m; iec <= n; iec++) {
    iea = iec - m + 1;
    _y[_ore[iec-1] - 1] = z[_ore[iec-1] - 1] + 0.1157407 * a[0][iea-1] +
	0.5489278 * a[2][iea-1] + 0.5353313 * a[3][iea-1] - 0.2 * a[4][iea-1];
  }
}


Void _sort(m, x, o_x, c)
short m;
double *x, *o_x;
Char c;
{
  _rl *p, *pf, *pa, *paa, *pr;
  _rl *pl = NULL;
  _rl *puc;
  boolean hc = true;

  pf = _fl[m-1];
  if (pf == NULL || pf->p == NULL)
    return;
  while (hc) {
    pa = pf;
    p = pa->p;
    paa = pa;
    hc = false;

    while (p != pl) {
      /*LINUX _uprv(p^.r,p^.b,p^.d); */
      /* actual   */
      /*LINUX _uprvo(pa^.r,pa^.b,pa^.d); */
      /* anterior */
      _uprv(p->r, p->b);   /* actual   */
      _uprvo(pa->r, pa->b);   /* anterior */
      if ((*x > *o_x) != (c == 'A'))
      {  /* reordenar si crec. y x>o_x o bien si decr. y x<=o-x */
	paa->p = p;
	pa->p = p->p;
	p->p = pa;
	if (pa == pf) {
	  _fl[m-1] = p;
	  pf = p;
	}
	pr = p;
	p = pa;
	pa = pr;
	puc = p;
	hc = true;
	if (p->p == NULL)
	  _ll[m-1] = p;
      }

      paa = pa;
      pa = p;
      p = p->p;
    }

    pl = puc;
  }
}  /*SORT*/


/*LINUX*/


/************************************************************_GRAPH***/
Void _graph(tg, nv, col, titul, nomv, minv, maxv, colv, f1, f2, x)
Char tg;
short nv;
uchar col;
Char *titul;
Char (*nomv)[13];
double *minv, *maxv;
unsigned short *colv;
short *f1, *f2;
double *x;
{
  short i, j, ptext;
  short xin = 60, yin = 60;
  short kx, ky, ks, usedpos, panmaxy1;
  Char nume[9];
  Char nom[8];
  double ri;
  short n[2];
  /*LINUX*/
  short WinW, WinH;
  /*LINUX*/
  EventStructure Evento;
  static Char MensContinue[256] = "Press any key to continue";
  Char STR1[256];
  Char STR2[10];
  Char STR3[16];
  Char STR4[12];

  if (_bpg) {   /*inicializacion del grafico*/
    _bpg = false;
    _bgr = true;
    /*LINUX _dirbgi:=''; */
    /***ojo ver vepsos en fung y .pas*/
    _dirbgi = "GLIDER Graph";   /***ojo ver vepsos en fung y .pas*/
    /*LINUX
       if paramcount=_posparmbgi then _dirbgi:=paramstr(_posparmbgi);*/
    /*LINUX*/
    WinW = 600;
    WinH = 600;
    if (_gr) {
      /*LINUX initgraph(_detect,_grm, _dirbgi)  ;*/
/* p2c: pp.pas, line 1376: Warning: Mixing non-strings with strings [170] */
      InitGraph(&WinW, &WinH, _dirbgi);
    }
    ClearDevice();
    SetBkColor(col);
    ptext = 15;
    _kgr = 1;
    panmaxx = (long)floor(GetMaxX() * escax + 0.5);
    panmaxy = (long)floor(GetMaxY() * escay + 0.5);
    /*incorporar los if !!!!!!*/
    /*posicion de los ejes el X en el cero de var2, el Y en el de var1*/
    if (minv[1] > 0)
      kx = 0;
    else
      kx = 1;
    /*si comienza con valor positivo*/
    if (minv[0] > 0)
      ky = 0;
    else
      ky = 1;
    /*ponerlo en el extremo (o casi?)*/
    /*LINUX _linx:=round(panmaxy*(1+kx*minv[2]/(maxv[2]-minv[2]))-40);
     _coly:=round(panmaxx*( -ky*minv[1]/(maxv[1]-minv[1]))+55);*/
    _linx = (long)floor(
	      panmaxy * (1 + kx * minv[1] / (maxv[1] - minv[1])) + 20 + 0.5);
    _coly = (long)floor(panmaxx * (ky * minv[0] / (minv[0] - maxv[0])) + 35 +
			(1 - ky) * 65 + 0.5) + 40;

    _dx = panmaxx / 12;
    _dy = panmaxy / 12;   /* o 13?? */

    /*numero de cuadros a cada lado de los ejes: n1,n2 negat. */
if(_minv[1] >= 0)  n[0]=0; else /*30.9.2002*/
    n[0] = (long)floor(minv[1] / (minv[1] - maxv[1]) * 10 + 0.5);
if(_minv[0] >= 0)  n[1]=0; else /*30.9.2002*/
    n[1] = (long)floor(minv[0] / (minv[0] - maxv[0]) * 10 + 0.5);
    if (n[0] == 0 && minv[1] < 0)
      n[0] = 1;
    if (n[1] == 0 && minv[0] < 0)
      n[1] = 1;
    /*limites del grafico*/
    /*Delphi 30.9.2002*/ _xmin = _coly - n[1] * _dx; 
    /*Delphi 30.9.2002*/ _xmax = _coly + (10 - n[1]) * _dx;
/*_xmin=_coly;  Delphi 30.9.2002*/ 
/*_xmax=_coly+10*_dx; Delphi 30.9.2002*/
    /*30.9.2002 _ymin = _linx + n[0] * _dy;*/
    /*30.9.2002 _ymax = _linx + (n[0] - 10) * _dy;*/
_ymin=_linx+n[0]*_dy; /*30.9.2002 Delphi*/ 
_ymax=_linx-(10-n[0])*_dy; /*30.9.2002 Delphi*/
    SetLineStyle(SolidLn, 0, ThickWidth);
    SetColor(colv[0]);
    Line(_xmin, _linx, _xmax, _linx);   /*eje TIME o X */
    SetColor(colv[1]);
    Line(_coly, _ymin, _coly, _ymax);   /*eje variable 1*/


    SetTextJustify(CenterText, TopText);
    /*LINUX settextstyle(0 {smallfont},1 {vertdir},0);*/
    /*para valores de eje X*/
    SetTextStyle(0, 1, 0);   /*para valores de eje X*/


    if (tg == 'T') {  /*si es tipo T ,poner*/
      ri = TIME;
      /*LINUX str(ri:f1[1]:f2[1]+1,nume);*/
      /*valor inicial eje horizontal*/
      sprintf(nume, "%*.*f", f1[0], f2[0], ri);
	  /*valor inicial eje horizontal*/
/* p2c: pp.pas, line 1417:
 * Note: Possible string truncation in assignment [145] */
      SetColor(colv[0]);
      /*LINUX outtextxy(_coly-1,_ymin+10,nume);*/
      /*-40*/
      /*PROB OutTextXY(_coly - 1, (int)(_ymin + strlen(nume) * 8), nume);*/   /*-40*/
      OutTextXY(_coly - 1, (int)(_ymin + 2), nume);   /*-40*/
    }

    SetLineStyle(DottedLn, 0, NormWidth);



    for (i = 0; i <= 10; i++) {   /*rayas verticales y valores X en graf. X*/
      SetColor(DarkGray);
      Line(_xmin + _dx * i, _ymin, _xmin + _dx * i, _ymax);
      if (tg == 'X') {   /*si X no es el tiempo poner numeros en X */
	SetColor(_colv[0]);
	if (i == n[1])
	  ri = 0.0;
	else
	  ri = minv[0] + (maxv[0] - minv[0]) / 10 * i;
	sprintf(nume, "%*.*f", f1[0], f2[0], ri);
/* p2c: pp.pas, line 1436:
 * Note: Possible string truncation in assignment [145] */
	/*LINUX outtextxy(_xmin+_dx*(i+1)-48,_ymin+10,nume);*/
	/*PROB OutTextXY(_xmin + _dx * (i + 1) - 48, (int)(_ymin + strlen(nume) * 8),
		  nume);*/
	OutTextXY(_xmin + _dx * (i + 1) - 48, (int)(_ymin + 2),
		  nume);

      }
    }

    SetTextJustify(CenterText, CenterText);
    /*LINUX settextstyle(smallfont,horizdir,1);*/
    SetTextStyle(0, 0, 0);


    for (i = 0; i <= 10; i++) {   /*rayas horizontales y valores Y */
      SetColor(DarkGray);
      Line(_xmin, _ymin - _dy * i, _xmax, _ymin - _dy * i);
      SetColor(_colv[1]);
      sprintf(nume, "%*.*f",
	      f1[0], f2[0] + 1, minv[1] + (maxv[1] - minv[1]) / 10 * i);
/* p2c: pp.pas, line 1453:
 * Note: Possible string truncation in assignment [145] */
      /*LINUX outtextxy(_coly-length(nume)*8,_ymin-_dy*i+2,nume); */
      /*20   -1*/
      OutTextXY((int)(_xmin - strlen(nume) * 8), _ymin - _dy * i + 2, nume);
	  /*20   -1*/
    }

    SetLineStyle(SolidLn, 0, NormWidth);

    if (tg == 'T')
      j = 2;
    else
      j = 1;
    /*LINUX  panmaxy1:=panmaxy+22;*/
    /*1996*/
    panmaxy1 = GetMaxY() - 40;
    MoveTo(ptext, panmaxy1);   /*panmaxy-10*/
    /*1996*/
    SetTextJustify(LeftText, TopText);
    usedpos = 0;
    for (i = j - 1; i <= nv - 1; i++)
    {   /*poner nombres y escalas de variables*/
      SetColor(colv[i]);
      strcpy(nom, nomv[i]);
      sprintf(STR2, "%s ", nom);
/* p2c: pp.pas, line 1467:
 * Note: Possible string truncation in assignment [145] */
      OutText(STR2);
      sprintf(nume, "%*.*f", f1[i], f2[i], minv[i]);
      sprintf(STR3, "%s%s", nom, nume);
/* p2c: pp.pas, line 1469:
 * Note: Possible string truncation in assignment [145] */
      usedpos += strlen(STR3) + 1;   /*1996*/
      ks = 1;
      while (nume[ks-1] == ' ')
	ks++;
      strdelete((Anyptr)nume, 1, ks - 1);
      OutText(nume);
      sprintf(nume, "%*.*f", f1[i], f2[i], maxv[i]);
/* p2c: pp.pas, line 1473:
 * Note: Possible string truncation in assignment [145] */
      ks = 1;
      while (nume[ks-1] == ' ')
	ks++;
      strdelete((Anyptr)nume, 1, ks - 1);
      sprintf(STR4, ":%s ", nume);
      OutText(STR4);
      usedpos += strlen(nume) + 2;   /*1996*/
      if (usedpos > 80) {   /*1996*/
	usedpos = 0;
	panmaxy1 += 20;
	MoveTo(ptext, panmaxy1);
      }
      /*1996*/
    }

    /*LINUX    if tg='X' then begin setcolor(WHITE); outtextxy(135,15,titul) end;*/
    /*LINUX*/
    /*WHITE*/
    SetColor(colv[0]);
    if (tg == 'X')
      OutTextXY(_xmin, 40, titul);

    /*poner puntos iniciales;  valor de abscisa*/
    if (tg == 'T')
      _jgr[0] = _coly;

    for (i = 1; i <= nv - 1; i++) {
      _lgr[i] = (long)floor(_linx - x[i] * 10 * _dy / (maxv[i] - minv[i]) + 0.5);
      if (tg == 'T')
	_jgr[i] = _coly;
      else
	_jgr[i] = (long)floor(_coly + x[0] * 10 * _dx / (maxv[0] - minv[0]) + 0.5);
      PutPixel(_jgr[i], _lgr[i], colv[i]);
    }

    return;
  }  /*fin de arranque del grafico*/

  /*cartelito de la hora; solo en caso X ? */
  /*LINUX   setcolor(BLACK); outtextxy(panmaxx-110,20,_nume);*/
  SetColor(col);
  OutTextXY(panmaxx, 40, _nume);
  sprintf(_nume, "%*.*f", f1[0], f2[0], TIME);   /*WHITE*/
/* p2c: pp.pas, line 1505:
 * Note: Possible string truncation in assignment [145] */
  /*LINUX    setcolor(WHITE); outtextxy(panmaxx-110,20,_nume);*/
  SetColor(_colv[0]);
  OutTextXY(panmaxx, 40, _nume);
  /*LINUX   if tg='T' then outtextxy(100,15,titul);*/
  if (tg == 'T')
    OutTextXY(_xmin, 40, titul);
  for (i = 1; i <= nv - 1; i++) {
    SetColor(colv[i]);
    MoveTo(_jgr[i], _lgr[i]);
    if (tg == 'T')
      _jgr[i]++;   /*incremento eje horizontal*/
    else
      _jgr[i] = (long)floor(_coly + x[0] * 10 * _dx / (maxv[0] - minv[0]) + 0.5);
    _lgr[i] = (long)floor(_linx - x[i] * 10 * _dy / (maxv[i] - minv[i]) + 0.5);
    LineTo(_jgr[i], _lgr[i]);

    if (tg == 'T' && _jgr[1] == _kgr * _dx + _xmin - 2 && i == 1) {
      sprintf(nume, "%*.*f", f1[0], f2[0], x[0]);
/* p2c: pp.pas, line 1523:
 * Note: Possible string truncation in assignment [145] */
      SetColor(colv[0]);
      /*LINUX settextstyle(smallfont,vertdir,1);*/
      SetTextStyle(0, 1, 0);
      /*LINUX        outtextxy(_jgr[2]+7,_ymin+10,nume);*/
      /*PROB OutTextXY(_jgr[1], (int)(_ymin + strlen(nume) * 8), nume);*/
      OutTextXY(_jgr[1], (int)(_ymin + 2), nume);
      _kgr++;
    }
  }

  /*LINUX settextstyle(smallfont,horizdir,1);*/
  SetTextStyle(0, 0, 0);

  if (tg == 'T')
    _jgr[0]++;

  /*parada de fin de pantalla*/
  /*LINUX if (tg='T') and (_jgr[1]+1>=_xmax)*/
  if (tg == 'T' && (_jgr[0] + 1 >= _xmax )) {
    _bpg = true;
    _ch = ' ';
    /*LINUX while _ch<>'C' do
     begin */
    /*LINUX*/
    /*LINUX*/
    /*DefaultFont*/
    /*HorizDir*/
    /*1*/
    SetTextStyle(0, 0, 16);
    /*LINUX*/
    OutTextXY(_xmin + 100, 20, MensContinue);
    /*LINUX*/
    do {
      ThisEvent(2, &Evento);
/* p2c: pp.pas, line 1548:
 * Warning: Symbol 'THISEVENT' is not defined [221] */
      /*_n_graph*/
    } while (Evento.nwindow != 1);
    /*LINUX*/
    /*SmallFont*/
    /*HorizDir*/
    /*10*/
    /*1*/
    SetTextStyle(0, 0, 0);
    /*LINUX PROB DELAY(3000); _CH:='C'; */
    /*outtextxy(panmaxx-110,8,'C to continue');
    _ch:=upcase(readkey); */
    /*LINUX*  _ch:=upcase(readkey);
           end; */
    _gr = false;
  }
  /*LINUX*/
  ThisEvent(1, &Evento);
/* p2c: pp.pas, line 1557:
 * Warning: Symbol 'THISEVENT' is not defined [221] */
  /*LINUX*/
  if (Evento.nwindow == 1 && Evento.visibility == 0) {
    /*_n_graph*/
    /*LINUX*/
    _bpg = true;
    /*para los puntos siguientes al arranque*/
  }

}




/* End. */
