/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "glfix.pas" */


#include <p2c/p2c.h>


/*Corrige mala generacion de declaracion de procedimientos nodo
  por p2c.

  Marta Sananes 25.05.2000*/

Static FILE *proge, *progs;
Static boolean nodecnodo;
Static Char linea[256], linea_a[256], numero[256];
Static int i, n, coderr;
Static Char nomfile[256];
Static Char proge_NAME[_FNSIZE];
Static Char progs_NAME[_FNSIZE];


Static Void dofix()
{
  int i, idec, icor, iigu, icoma;
  Char STR1[256];
  Char *TEMP;
  int FORLIM;

  idec = strpos2(linea, "_prnod[", 1);
  icor = strpos2(linea, "]", 1);
  strsub(numero, linea, idec + 7, icor - idec - 7);
  coderr = (sscanf(numero, "%d", &n) == 0);
  if (coderr != 0) {
    printf("ERROR in c program\n");
    _Escape(0);
  }
  fprintf(progs, "%s\n", linea);   /*pasa linea de comiezo declaracion*/
  fgets(linea, 256, proge);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  FORLIM = n;
  for (i = 1; i <= FORLIM; i++) {
    do {
      iigu = strpos2(linea, "=", 1);
      if (iigu == 0) {
	fgets(linea, 256, proge);
	TEMP = strchr(linea, '\n');
	if (TEMP != NULL)
	  *TEMP = 0;
      }
    } while (iigu == 0);
    strcpy(linea,
	   strsub(STR1, linea, iigu + 2, (int)(strlen(linea) - iigu + 1)));
    icoma = strpos2(linea, ",", 1);
    if (i == n)   /*el ultimo sin la coma*/
      icoma--;
    sprintf(linea_a, "%.*s", icoma, linea);
    fprintf(progs, "%s\n", linea_a);
    strcpy(linea, strsub(STR1, linea, icoma + 1, strlen(linea) - icoma));
  }
  fgets(linea, 256, proge);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  fprintf(progs, "%s\n", linea);   /*la que cierra la llave*/
  fgets(linea, 256, proge);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)   /*eliminar declaraciones TEMP*/
    *TEMP = 0;
  FORLIM = n;
  for (i = 1; i <= FORLIM; i++) {
    fgets(linea, 256, proge);
    TEMP = strchr(linea, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  fgets(linea, 256, proge);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
}


main(argc, argv)
int argc;
Char *argv[];
{
  Char *TEMP;

  PASCAL_MAIN(argc, argv);
  progs = NULL;
  proge = NULL;
  if (P_argc == 1) {
    printf("ERROR: no program defined\n");
    _Escape(0);
  }
  strcpy(nomfile, P_argv[1]);
  strcpy(proge_NAME, nomfile);
  n = strlen(nomfile);
  if (nomfile[n-1] != 'c') {
    printf("ERROR: not a c program\n");
    _Escape(0);
  }
  nomfile[n-1] = 'n';
  strcpy(progs_NAME, nomfile);
  if (proge != NULL)
    proge = freopen(proge_NAME, "r", proge);
  else
    proge = fopen(proge_NAME, "r");
  if (proge == NULL)
    _EscIO2(FileNotFound, proge_NAME);
  if (progs != NULL)
    progs = freopen(progs_NAME, "w", progs);
  else
    progs = fopen(progs_NAME, "w");
  if (progs == NULL)
    _EscIO2(FileNotFound, progs_NAME);
  nodecnodo = true;

  fgets(linea, 256, proge);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  while (nodecnodo) {
    if (*linea != '\0' && linea[0] == 'S') {
      dofix();
      nodecnodo = false;
      break;
    }
    fprintf(progs, "%s\n", linea);
    fgets(linea, 256, proge);
    TEMP = strchr(linea, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  while (!P_eof(proge)) {
    fprintf(progs, "%s\n", linea);
    fgets(linea, 256, proge);
    TEMP = strchr(linea, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  fprintf(progs, "%s\n\n", linea);
  if (proge != NULL)
    fclose(proge);
  proge = NULL;
  if (progs != NULL)
    fclose(progs);
  progs = NULL;
  exit(EXIT_SUCCESS);
}




/* End. */
