/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "glfixpru.pas" */


#include <p2c/p2c.h>


/*Corrige mala generacion de declaracion de Variables Continuas
  para LINUX.

  Marta Sananes 31.05.2000*/

Static FILE *pruh, *pruhn, *pruc, *prucn;
Static boolean noextern, notypedef, novextern, siguemas;
Static Char linea[256], lineah[256], linea_a[256], lineapru[256], numero[256];
Static short i, j, jSep, n, coderr, dimTot, sDim;
Static Char nomfile[256];
Static Char vcon[100][256];
Static short vdim[100];
Static short icor;
Static boolean HuboCambio;
Static Char pruh_NAME[_FNSIZE];
Static Char pruhn_NAME[_FNSIZE];
Static Char pruc_NAME[_FNSIZE];
Static Char prucn_NAME[_FNSIZE];


/* Local variables for fixcont: */
struct LOC_fixcont {
  Char separ[26];
} ;

Local boolean esletra(c, LINK)
Char c;
struct LOC_fixcont *LINK;
{
  /*26.7.2001
    if ((c >='A') and (c<='Z')) or ((c>='a') and (c<='z')) then esletra:=true;*/
/* p2c: glfixpru.pas: Note: Eliminated unused assignment statement [338] */
  if (isalpha(c) || c == '_')
    return true;
  return false;
}

Local boolean esseparador(c, LINK)
Char c;
struct LOC_fixcont *LINK;
{
  boolean Result = false;
  uchar k = 1;
  boolean sigue = true;

  /*26.7.2001 while (k<=27) and sigue do begin*/
  while (k <= 26 && sigue) {
    if (c == LINK->separ[k-1]) {
      sigue = false;
      Result = true;
    } else
      k++;
  }
  return Result;
}


Static Void fixcont(arch, archn, soloprimera)
FILE **arch, **archn;
boolean soloprimera;
{
  /*Corrige mala generacion de declaracion de Variables Continuas
    para LINUX.

    Marta Sananes 9.10.2000*/
  struct LOC_fixcont V;

  static Char separ[26] = {
    ' ', ';', '=', ':', '(', ')', '[', ']', ',', '-', '+', '*', '/', '^', '&',
    '|', '<', '>', '{', '}', '#', '\'', '@', '%', '\\', '!'
  };

  /*26.7.2001
const separ: array[1..27] of char =
        (' ',';','=',':','(',')','[',']',',','-','+','*','/',
         '^','&','|','<','>','{','}','#','''','@','%','\','!','_'); */

  boolean esblanco, nocontinua, nofincomen, siguemas;
  boolean noSale = true;
  short i = 1;
  short j, iC, iSep;
  Char nom[256];
  Char *TEMP;


  memcpy(V.separ, separ, sizeof(Char[26]));
  /*Procedimiento de corregir nombres simples*/
  /*Debe venir ya un registro leido en linea*/
  HuboCambio = false;
  while (!P_eof(*arch) && noSale) {
    /*writeln('i: ',i,': ',linea); readln;*/
    esblanco = true;
    while (i <= strlen(linea) && esblanco) {
      if (linea[i-1] != ' ')
	esblanco = false;
      else
	i++;
    }  /*es linea en blanco*/
    if (esblanco) {
      fprintf(*archn, "%s\n", linea);
      fgets(linea, 256, *arch);
      TEMP = strchr(linea, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
      i = 1;
      continue;
    }
    iC = i;   /*posicion de primer caracter*/
    i++;
    /*writeln('iC: ',iC,' C: ',linea[iC]); readln;*/
    if (esletra(linea[iC-1], &V)) {  /*es identificador*/
      /*writeln('entra por identificador'); readln;*/
      siguemas = true;
      while (i <= strlen(linea) && siguemas) {
	if (esseparador(linea[i-1], &V))
	  siguemas = false;
	else
	  i++;
      }  /*siguemas*/
      iSep = i;
      strsub(nom, linea, iC, iSep - iC);
      /*writeln('NOMBRE: ',nom); readln;*/
      j = 1;
      nocontinua = true;
      while (j <= n && nocontinua) {
	if (!strcmp(nom, vcon[j-1]))
	  nocontinua = false;
	else
	  j++;
      }  /*nocontinua*/
      if (!nocontinua) {
	strinsert("*", (Anyptr)linea, iC);
	HuboCambio = true;
	if (soloprimera) {
	  jSep = iSep + 1;
	  noSale = false;
	}
      }
      i = iSep + 1;
      if (iSep <= strlen(linea))
	continue;
      fprintf(*archn, "%s\n", linea);
      fgets(linea, 256, *arch);
      TEMP = strchr(linea, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
      i = 1;
      continue;
    }  /*es identificador*/
    if (strlen(linea) < 2 || linea[iC-1] != '/' || linea[iC] != '*')
    {  /*es comentario*/
      /*writeln('entra por otro'); readln;*/
      i = iC + 1;
      continue;
    }  /*es comentario*/
    /*writeln('entra por comentario'); readln;*/
    nofincomen = true;
    iSep = iC + 2;
    while (nofincomen) {
      while (iSep <= strlen(linea) - 1 && nofincomen) {
	if (linea[iSep-1] == '*' && linea[iSep] == '/')
	  nofincomen = false;
	else
	  iSep++;
      }  /*nofincomen*/
      if (!nofincomen) {
	i = iSep + 2;
	break;
      }
      fprintf(*archn, "%s\n", linea);
      fgets(linea, 256, *arch);
      TEMP = strchr(linea, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
      iSep = 1;
    }  /*while nofincomen*/
  }  /*not eof and noSale*/
  /*no es linea en blanco*/
  /*no es identificador*/
  /*no es identificador*/
  /*no es linea en blanco*/

  /*Los archivos se cierran afuera*/
  if (noSale)
    fprintf(*archn, "%s\n\n", linea);
}


main(argc, argv)
int argc;
Char *argv[];
{  /*Main*/
  Char *TEMP;
  Char STR1[256];
  short FORLIM;

  PASCAL_MAIN(argc, argv);
  prucn = NULL;
  pruc = NULL;
  pruhn = NULL;
  /*Hay simples que arreglar*/

  pruh = NULL;
  siguemas = false;
  strcpy(nomfile, "pru.c");
  strcpy(pruc_NAME, "pru.c");
  nomfile[4] = 'n';
  strcpy(prucn_NAME, nomfile);
  if (pruc != NULL)
    pruc = freopen(pruc_NAME, "r", pruc);
  else
    pruc = fopen(pruc_NAME, "r");
  if (pruc == NULL)
    _EscIO2(FileNotFound, pruc_NAME);
  if (prucn != NULL)
    prucn = freopen(prucn_NAME, "w", prucn);
  else
    prucn = fopen(prucn_NAME, "w");
  if (prucn == NULL)
    _EscIO2(FileNotFound, prucn_NAME);
  noextern = true;
  fgets(linea, 256, pruc);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  /*Buscar extern double *_y = */
  while (noextern) {
    if (strlen(linea) > 20 && !strcmp((sprintf(STR1, "%.20s", linea), STR1),
				      "extern double *_y = ")) {
      noextern = false;
      break;
    }
    fprintf(prucn, "%s\n", linea);
    fgets(linea, 256, pruc);
    TEMP = strchr(linea, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  /*writeln('pru.c extern double *_y = & :',linea); readln;*/
  /*ojo, si no es vector, empieza con &*/
  strsub(vcon[0], linea, 21, (int)(strlen(linea) - 20));
  /*writeln('recogido en vcon[1]: ',vcon[1]);*/
  if (!strcmp(vcon[0], "&it;")) {  /*no hay continuas, nada que arreglar*/
    if (pruc != NULL)
      fclose(pruc);
    pruc = NULL;   /*close(prucn);*/
    _Escape(0);
  }
  /*writeln('sale, nada que arreglar'); readln;*/
  sprintf(STR1, "%.*s", (int)(strlen(vcon[0]) - 1), vcon[0]);
  /*quitar coma*/
  strcpy(vcon[0], STR1);
  if (vcon[0][0] == '&')
    strcpy(vcon[0], strsub(STR1, vcon[0], 2, (int)(strlen(vcon[0]) - 1)));
  /*arreglar primero el pru.h*/
  /*se guarda linea para poder usar fixcont con pruh*/
  strcpy(lineapru, linea);
  strcpy(nomfile, "pru.h");
  strcpy(pruh_NAME, "pru.h");
  nomfile[4] = 'j';
  strcpy(pruhn_NAME, nomfile);
  if (pruh != NULL)
    pruh = freopen(pruh_NAME, "r", pruh);
  else
    pruh = fopen(pruh_NAME, "r");
  if (pruh == NULL)
    _EscIO2(FileNotFound, pruh_NAME);
  if (pruhn != NULL)
    pruhn = freopen(pruhn_NAME, "w", pruhn);
  else
    pruhn = fopen(pruhn_NAME, "w");
  if (pruhn == NULL)
    _EscIO2(FileNotFound, pruhn_NAME);
  notypedef = true;
  fgets(lineah, 256, pruh);
  TEMP = strchr(lineah, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  /*Buscar typedef double _arrv[*/
  while (notypedef) {
    if (strlen(lineah) > 21 &&
	!strcmp((sprintf(STR1, "%.21s", lineah), STR1),
		"typedef double _arrv[")) {
      notypedef = false;
      break;
    }
    fprintf(pruhn, "%s\n", lineah);
    fgets(lineah, 256, pruh);
    TEMP = strchr(lineah, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  /*writeln('pru.h typedef double _arrv[ :',lineah); readln;*/
  strsub(numero, lineah, 22, (int)(strlen(lineah) - 21));
  /*icor:=index(']',numero);  numero:=copy(numero,1,icor-1);*/
  icor = strpos2(numero, "]", 1);
  sprintf(numero, "%.*s", icor - 1, strcpy(STR1, numero));
  coderr = (sscanf(numero, "%d", &dimTot) == 0);
  /*writeln('dimTot: ',dimTot); readln;*/
  fprintf(pruhn, "%s\n", lineah);
  novextern = true;
  fgets(lineah, 256, pruh);
  TEMP = strchr(lineah, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  /*Buscar primer vextern*/
  while (novextern) {
    if (strlen(lineah) > 7 &&
	!strcmp((sprintf(STR1, "%.7s", lineah), STR1), "vextern")) {
      novextern = false;
      break;
    }
    fprintf(pruhn, "%s\n", lineah);
    fgets(lineah, 256, pruh);
    TEMP = strchr(lineah, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  strcpy(linea_a, "vextern _arrv _y;");
  fprintf(pruhn, "%s\n", linea_a);
  /*quitada mala  writeln(pruhn,lineah); */
  /*writeln('vcon[1]: ',vcon[1]); readln;*/

  /*Buscar vextern double con 1a. continua*/
  n = 1;
  strcpy(linea, lineah);
  fixcont(&pruh, &pruhn, true);
  strcpy(lineah, linea);
  /*writeln(lineah[jSep], ':',lineah); readln;*/
  /*19.9.2000 Se agrega caso declaracion en la misma linea*/
  if (lineah[jSep-1] == ';' || lineah[jSep-1] == ',') {
    vdim[0] = 0;   /*0 para fixcont*/
    if (lineah[jSep-1] == ',') {
      siguemas = true;
      lineah[jSep-1] = ';';
    }
    sprintf(linea_a, "%.*s", jSep, lineah);
    strcpy(lineah, strsub(STR1, lineah, jSep + 1, strlen(lineah) - jSep));
  } else {
    strsub(numero, lineah, jSep + 1, strlen(lineah) - jSep);
    /*icor:=index(']',numero);*/
    icor = strpos2(numero, "]", 1);
    sprintf(linea_a, "%.*s;", jSep - 1, lineah);
    if (numero[icor] == ',')
      siguemas = true;
    strsub(lineah, numero, icor + 2, (int)(strlen(numero) - icor + 1));
    sprintf(numero, "%.*s", icor - 1, strcpy(STR1, numero));
    coderr = (sscanf(numero, "%d", vdim) == 0);
  }
  sDim = vdim[0];
  if (vdim[0] == 0)
    sDim++;
  /*linea_a:='vextern double *'+vcon[1]+';';*/
  fprintf(pruhn, "%s\n", linea_a);
  i = 1;
  while (sDim < dimTot) {   /*termino con coma hay que tomar siguiente*/
    if (siguemas) {
      novextern = true;
      while (novextern) {
	i = 1;
	while (i <= strlen(lineah) && lineah[i-1] == ' ')
	  i++;
	if (i > strlen(lineah)) {
	  fgets(lineah, 256, pruh);
	  TEMP = strchr(lineah, '\n');
	  if (TEMP != NULL)
	    *TEMP = 0;
	} else {
	  n++;
	  strsub(vcon[n-1], lineah, i, (int)(strlen(lineah) - i + 1));
	  novextern = false;
	}
      }
    } else {
      fprintf(pruhn, "%s\n", lineah);
      novextern = true;
      fgets(lineah, 256, pruh);
      TEMP = strchr(lineah, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
      /*Buscar vextern de proxima continua*/
      while (novextern) {
	if (strlen(lineah) > 15 &&
	    !strcmp((sprintf(STR1, "%.15s", lineah), STR1), "vextern double ")) {
	  novextern = false;
	  break;
	}
	fprintf(pruhn, "%s\n", lineah);
	fgets(lineah, 256, pruh);
	TEMP = strchr(lineah, '\n');
	if (TEMP != NULL)
	  *TEMP = 0;
      }
      n++;
      strsub(vcon[n-1], lineah, 16, (int)(strlen(lineah) - 15));
    }
    /*icor:=index('[',vcon[n]); */
    icor = strpos2(vcon[n-1], "[", 1);
    if (icor == 0) {
      vdim[n-1] = 0;   /*0 para fixcont*/
      /*icor:=index(',',vcon[n]); */
      icor = strpos2(vcon[n-1], ",", 1);
      if (icor != 0)
	siguemas = true;
      else {
	siguemas = false;
	/*icor:=index(';',vcon[n]); */
	icor = strpos2(vcon[n-1], ";", 1);
      }
      /*if icor<>0 then
      begin */
      strsub(lineah, vcon[n-1], icor + 1, strlen(vcon[n-1]) - icor);
      sprintf(STR1, "%.*s", icor - 1, vcon[n-1]);
      strcpy(vcon[n-1], STR1);
      /*end;*/
    } else {
      strsub(numero, vcon[n-1], icor + 1, strlen(vcon[n-1]) - icor);
      sprintf(STR1, "%.*s", icor - 1, vcon[n-1]);
      strcpy(vcon[n-1], STR1);
      /*icor:=index(']',numero);*/
      icor = strpos2(numero, "]", 1);
      if (numero[icor] == ',')
	siguemas = true;
      else
	siguemas = false;
      strsub(lineah, numero, icor + 2, (int)(strlen(numero) - icor + 1));
      sprintf(numero, "%.*s", icor - 1, strcpy(STR1, numero));
      coderr = (sscanf(numero, "%d", &vdim[n-1]) == 0);
    }
    sprintf(linea_a, "vextern double *%s;", vcon[n-1]);
    fprintf(pruhn, "%s\n", linea_a);
    if (!siguemas)
      fprintf(pruhn, "%s\n", lineah);
    /*writeln('var ',n,': ',vcon[n],' dim: ',vdim[n]); readln;*/
    sDim += vdim[n-1];
    if (vdim[n-1] == 0)
      sDim++;
  }
  /*writeln('n# continuas: ',n, 'sDim: ',sDim); readln;*/
  noextern = true;
  fgets(lineah, 256, pruh);
  TEMP = strchr(lineah, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  /*Buscar extern double *_y;*/
  while (noextern) {
    if (strlen(lineah) > 17 &&
	!strcmp((sprintf(STR1, "%.18s", lineah), STR1), "extern double *_y;")) {
      noextern = false;
      break;
    }
    fprintf(pruhn, "%s\n", lineah);
    fgets(lineah, 256, pruh);
    TEMP = strchr(lineah, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  /*no se pasa*/
  fgets(lineah, 256, pruh);
  TEMP = strchr(lineah, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  while (!P_eof(pruh)) {
    fprintf(pruhn, "%s\n", lineah);
    fgets(lineah, 256, pruh);
    TEMP = strchr(lineah, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  }
  fprintf(pruhn, "%s\n\n", lineah);
  if (pruh != NULL)
    fclose(pruh);
  pruh = NULL;
  if (pruhn != NULL)
    fclose(pruhn);
  pruhn = NULL;

  /*continua arreglo de pru.c*/
  sprintf(linea, "extern double *%s = _y;", vcon[0]);
  sDim = vdim[0];
  if (vdim[0] == 0)
    sDim++;
  fprintf(prucn, "%s\n", linea);
  FORLIM = n;
  for (i = 2; i <= FORLIM; i++) {
    sprintf(numero, "%d", sDim);
    /*writeln('s dim ',i,': ',numero); readln;*/
    sprintf(linea, "extern double *%s = &_y[%s];", vcon[i-1], numero);
    fprintf(prucn, "%s\n", linea);
    sDim += vdim[i-1];
    if (vdim[i-1] == 0)
      sDim++;
    /*writeln('sDim: ', sDim); readln;*/
  }
  /*writeln('dim ',i,': ',vdim[i]); readln;*/
  fgets(linea, 256, pruc);
  TEMP = strchr(linea, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  /*Arreglo de variables simples, si hay*/
  /*Dejar en vcon solo las simples*/
  i = 1;
  while (i <= n) {
    if (vdim[i-1] == 0)
      i++;
    else {
      FORLIM = n;
      for (j = i; j <= FORLIM - 1; j++) {
	strcpy(vcon[j-1], vcon[j]);
	vdim[j-1] = vdim[j];
      }
      n--;
    }
  }
  if (n == 0) {
    while (!P_eof(pruc)) {
      fprintf(prucn, "%s\n", linea);
      fgets(linea, 256, pruc);
      TEMP = strchr(linea, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
    }
    fprintf(prucn, "%s\n\n", linea);
    if (pruc != NULL)
      fclose(pruc);
    pruc = NULL;
    if (prucn != NULL)
      fclose(prucn);
    prucn = NULL;
  } else {
    fixcont(&pruc, &prucn, false);
    if (pruc != NULL)
      fclose(pruc);
    pruc = NULL;
    if (prucn != NULL)
      fclose(prucn);
    prucn = NULL;
    /*Sigue reparando las unids*/
    siguemas = true;
    strcpy(nomfile, "unid1.c");
    strcpy(pruc_NAME, nomfile);
    nomfile[6] = 'n';
    strcpy(prucn_NAME, nomfile);
    if (pruc != NULL)
      pruc = freopen(pruc_NAME, "r", pruc);
    else
      pruc = fopen(pruc_NAME, "r");
    if (pruc == NULL)
      _EscIO2(FileNotFound, pruc_NAME);
    if (prucn != NULL)
      prucn = freopen(prucn_NAME, "w", prucn);
    else
      prucn = fopen(prucn_NAME, "w");
    if (prucn == NULL)
      _EscIO2(FileNotFound, prucn_NAME);
    fgets(linea, 256, pruc);
    TEMP = strchr(linea, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
    fixcont(&pruc, &prucn, false);
    if (pruc != NULL)
      fclose(pruc);
    pruc = NULL;
    if (HuboCambio) {
      if (prucn != NULL)
	fclose(prucn);
      prucn = NULL;
    }
    i = 2;
    while (siguemas) {
      if (i < 10)
	sprintf(numero, "%d", i);
      else
	sprintf(numero, "%2d", i);
      sprintf(nomfile, "unid%s.c", numero);
      strcpy(pruc_NAME, nomfile);
      if (pruc != NULL)
	pruc = freopen(pruc_NAME, "r", pruc);
      else
	pruc = fopen(pruc_NAME, "r");
      _SETIO(pruc != NULL, FileNotFound);
      if (P_ioresult != 0) {
	siguemas = false;
	break;
      }
      sprintf(nomfile, "unid%s.n", numero);
      strcpy(prucn_NAME, nomfile);
      if (prucn != NULL)
	prucn = freopen(prucn_NAME, "w", prucn);
      else
	prucn = fopen(prucn_NAME, "w");
      if (prucn == NULL)
	_EscIO2(FileNotFound, prucn_NAME);
      fgets(linea, 256, pruc);
      TEMP = strchr(linea, '\n');
      if (TEMP != NULL)
	*TEMP = 0;
      fixcont(&pruc, &prucn, false);
      if (pruc != NULL)
	fclose(pruc);
      pruc = NULL;
      if (HuboCambio) {
	if (prucn != NULL)
	  fclose(prucn);
	prucn = NULL;
      }
      i++;
    }

  }
  if (pruh != NULL)
    fclose(pruh);
  if (pruhn != NULL)
    fclose(pruhn);
  if (pruc != NULL)
    fclose(pruc);
  if (prucn != NULL)
    fclose(prucn);
  exit(EXIT_SUCCESS);
}





/* End. */
