/* cturbo.h  Ex-ccturbo.h LINUX

   Declaraciones para incluir en programas 'c' para la
   Libreria de emulacion de rutinas de turboPascal 'cturbo.c'.
   Contiene las siguientes rutinas:

*/

#ifndef CTURBO
#define CTURBO

#ifdef CTURBO_G
#define vextern
#else 
#define vextern extern
#endif

#define getch() getchar()

vextern char gotoxy_str[15]; /* = ""; */
vextern short int wherex, wherey; /* = 0;*/
vextern unsigned char reversevideo; /* = 0;*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

void clrscr();

void delay(float x);

void freemem(void * *p, int nbytes);

void getmem(void * *p, int nbytes);

void gotoxy(unsigned char x, unsigned char y);

void seek_c(FILE *f, int r_size, long int nr);

void set_normalvideo();

void set_reversevideo();

void str_c(void *x, const char *format, int *len,  char *s); 

void val_c(char *s, void *x, int tipo, int *codErr);

unsigned char kbhit();

void GetTime(unsigned short *h,unsigned short *m,unsigned short *s,unsigned short *s100);

void GetDate(unsigned short *y,unsigned short *m,unsigned short *d,unsigned short *wd);

double _randreal();

#undef vextern

#endif
/*end.*/


