/* Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator */
/* From input file "ug2.pas" */


#include <p2c/p2c.h>


#define UG2_G
#include "ug2.h"


Void tranlin(ij, bfl)
short ij;
boolean bfl;
{
  /* ren1 a buffer y trans.
   si se llena. 1:modec 2:modini 3:modpro 4:modnet 5:modaux 6:modini1
   7:modlog 8:modedi 9:modproc                        31/10/1998
   si bfl es true se vacia linbuf anterior y comienza nueva linea */
  if (strlen(ren1) > 74 - strlen(linbuf[ij-1]) || bfl) {
    switch (ij) {

    case 1:
      fprintf(modec, "%s\n", linbuf[0]);
      break;

    case 2:
      fprintf(modini, "%s\n", linbuf[1]);
      break;

    case 3:
      fprintf(modpro, "%s\n", linbuf[2]);
      break;

    case 4:
      fprintf(modnet, "%s\n", linbuf[3]);
      break;

    case 5:
      fprintf(modaux, "%s\n", linbuf[4]);
      break;

    case 6:
      fprintf(modini1, "%s\n", linbuf[5]);
      break;

    case 7:
      fprintf(modlog, "%s\n", linbuf[6]);
      break;

    case 8:
      fprintf(modedi, "%s\n", linbuf[7]);
      break;

    case 9:
      fprintf(modproc, "%s\n", linbuf[8]);
      break;
    }
    if (W)
      printf("TR.LIN  %s\n", linbuf[ij-1]);
    strcpy(linbuf[ij-1], ren1);
  } else
    strcat(linbuf[ij-1], ren1);
  if (W) {
    printf("A BUF %d %s\n", ij, ren1);
    UT = getchar();
  }
}


/******************************************************** LIMPBUF */
Void limpbuf(n)
short n;
{
  /* limpia buffer # n */
  switch (n) {

  case 1:
    fprintf(modec, "%s\n", linbuf[0]);
    *linbuf[0] = '\0';
    break;

  case 2:
    fprintf(modini, "%s\n", linbuf[1]);
    *linbuf[1] = '\0';
    break;

  case 3:
    fprintf(modpro, "%s\n", linbuf[2]);
    *linbuf[2] = '\0';
    break;

  case 4:
    fprintf(modnet, "%s\n", linbuf[3]);
    *linbuf[3] = '\0';
    break;

  case 5:
    fprintf(modaux, "%s\n", linbuf[4]);
    *linbuf[4] = '\0';
    break;

  case 6:
    fprintf(modini1, "%s\n", linbuf[5]);
    *linbuf[5] = '\0';
    break;

  case 7:
    fprintf(modlog, "%s\n", linbuf[6]);
    *linbuf[6] = '\0';
    break;

  case 8:
    fprintf(modedi, "%s\n", linbuf[7]);
    *linbuf[7] = '\0';
    break;

  case 9:
    fprintf(modproc, "%s\n", linbuf[8]);
    *linbuf[8] = '\0';
    break;
  }
}


/********************************************************* TRANHAS */
Void tranhas(j, h)
short j, h;
{
  /* transmite a h, desde ki a j-1 */
  strsub(ren1, pl->con, ki, j - ki);
  tranlin(h, false);
}


/*P*/
/********************************************************** INSER */
Void inser(esq, chrr, sust, ren2, uk)
Char *esq;
Char chrr;
Char *sust, *ren2;
short uk;
{
  /* pone el esqueleto en ren2 y el string sust donde hay chrr; si uk es
0 no lo imprime, 1 lo imprime en modec, 2 en modini, 3 en modpro   */
  short j;
  Char STR1[256];

  strcpy(ren2, esq);
  sprintf(STR1, "%c", chrr);
  j = strpos2(ren2, STR1, 1);
  while (j != 0) {
    strdelete((Anyptr)ren2, j, 1);
    strinsert(sust, (Anyptr)ren2, j);
    sprintf(STR1, "%c", chrr);
    j = strpos2(ren2, STR1, 1);
  }
  switch (uk) {

  case 0:
    /* blank case */
    break;

  case 1:
    fprintf(modec, "%s\n", ren2);
    break;

  case 2:
  case 3:
  case 4:
    tranlin(uk, false);
    break;
  }
}


/******************************************************** BUSIDAR1 */
Void busidar1()
{
  /* busca var,tipo en tipo bc=false o bva=false  */
  /* queda apuntada por pva; si halla deja bc:=false bva=true */
  short jjk, k0, m0;
  st10 nomx;
  Char STR2[256], STR3[256];

  if (W) {
    printf("ENTRADA A BUSIDAR1 CON %s\n", nom);
    UT = getchar();
  }
  bva = false;
  strcpy(tipo, " ");
  if (pvf != NULL) {   /* si hay arbol ir a buscar     */
    pva = pvf;   /* comenzando desde el primero                    */
    while (pva != NULL && !bva) {   /* mientras no se acabe ni se halle */
      /*IF W THEN WRITELN('EXAMINA EN ARBOL AL ',PVA^.NOM);  */
      if (!strcmp(pva->nom, nom)) {   /*hallado nombre igual; hallar el tipo*/
	if (!strcmp(prog, "MAIN")) {   /*procesando MAIN*/
	  if (!strcmp(pva->prog, "MAIN")) {
	    strcpy(tipo, pva->typ_);
	    bc = false;
	    bva = true;
	  }  /*se hallo*/
	}

	else {
	  if (!strcmp(pva->prog, prog)) {
	    strcpy(tipo, pva->typ_);
		/*la del proc es la primera de la lista*/
	    bc = false;
	    bva = true;   /*llaves de se hallo*/
	  } else {
	    if (W)
	      printf("BUSCANDO SINONIMO %s\n", nom);
	    psi = pva->psi;   /*apunta a primera o es nil */
	    while (psi != NULL && strcmp(psi->prog, prog))
	      psi = psi->psi;
	    if (psi == NULL) {
	      strcpy(tipo, pva->typ_);   /*es global*/
	      if (W) {
		printf("VER SI ES VAR GLOBAL TIPO %s\n", pva->typ_);
		UT = getchar();
	      }
	      if (!strcmp(pva->prog, "MAIN")) {
		bc = false;
		bva = true;
	      }
	    } else {
	      strcpy(tipo, psi->typ_);
	      pva = psi;
	      if (W) {
		printf("VAR LOCAL %s TIPO %s\n", pva->nom, pva->typ_);
		UT = getchar();
	      }

	      bc = false;
	      bva = true;   /*llaves de se hallo*/
	      /*es local*/

	    }
	  }
	}
	/*procesando procedimiento o NODE*/
	/*buscar si la del proc.es algun sinonimo*/
	goto _L1;   /*se da por terminada busqueda en arbol  3/11/1998*/
/* p2c: ug2.pas: Note: Deleting unreachable code [255] */
      }  /* del caso nombre igual*/


      jjk = strpos2(pva->nom, ".", 1);
	  /*busca punto;si no hay,pos da cero 3/11/1998*/
      /*si al buscado (nom) sigue . y si elem.arbol: tiene ., nombre
      igual a nom y es tabla DBASE, hay que ver el campo*/
      if (ch == '.' && jjk != 0 &&
	  !strcmp(nom, (sprintf(STR2, "%.*s", jjk - 1, pva->nom), STR2)) &&
	  pva->dbase) {
	/*guardar m, k y nombre tabla (nomx) recoger lo que
	           sigue al . o sea nombre de campo  3/11/1998*/
	m0 = m;
	k0 = k;
	k++;
	strcpy(nomx, nom);
/* p2c: ug2.pas, line 192:
 * Note: Possible string truncation in assignment [145] */
	recid();   /*ver lo que sigue al . (debe ser campo)*/
	/*si lo es termina busqueda*/
	if (!strcmp(nom, strsub(STR3, pva->nom, jjk + 1,
				strlen(pva->nom) - jjk))) {
	  bc = false;
	  bva = true;
	  strcpy(nom, pva->nom);
	  m = m0;
	  goto _L1;
	}  /*si no lo es recuperar nombre buscado*/
	m = m0;
	k = k0;
	strcpy(nom, nomx);
	ch = '.';
      }
      /*proseguir busqueda de anterior o siguiente*/
      if (strcmp(pva->nom, nom) >= 0)
	pva = pva->pa;
      else
	pva = pva->ps;   /*ant o sig*/
    }  /*del while que revisa arbol*/
  }
  /*no hubo nombre igual 3/11/1998*/
  /*del if todavia no se halla*/

_L1:
  if (!W)
    return;
  if (bva)
    printf("SE HALLO %s TIPO %s TYPTYP %s DE PROGR. %s\n",
	   pva->nom, tipo, pva->typtyp, pva->prog);
  else
    printf("NO ESTA EN ARBOL\n");
  UT = getchar();
}


/********************************************************BUSIDAR*/
Void busidar()
{
  /*busca en arbol si es rec.campo o apu^.campo
                        busca el campo */
  Char STR1[166];

  busidar1();   /*busqueda en arbol; termina si es simple o DBASE*/
  if (bva && !strcmp(pva->typtyp, "RECORD"))
  {   /**antes ver si es array!!*****++++=========*/
    strcpy(nom4, nom);
    if (W)
      printf("ENCONTRO TIPO RECORD %s BUSCA CAMPO  NOMFUNPG %s\n",
	     pva->nom, nomfunpg);
    if (ch == '.') {  /*debe seguir campo de record*/
      k++;
      recid();
      pvf1 = pvf;
      pvf = pva->apre;
      busidar1();   /*busca en lista de campos, si no esta es error*/
      if (!bva)
	error("invalid field name");
      pvf = pvf1;
      sprintf(nom, "%s.%s", nom4, strcpy(STR1, nom));
      if (W) {
	printf("HALLADO %s TIPO %s\n", nom, pva->typ_);
	UT = getchar();
      }
    }

  }  /*fin de caso record*/

  if (bva && !strcmp(pva->typtyp, "POINTER") && ch == '^' && pl->con[k] != '.') {
    k++;
    strcpy(nom4, nom);
    bc = false;
    sprintf(nom, "%s^", nom4);
    goto _L1;
  }


  if (bva && !strcmp(pva->typtyp, "POINTER") && ch == '^' && pl->con[k] == '.') {
    strcpy(nom4, nom);
    if (W)
      printf("ENCONTRO TIPO POINTER %s BUSCA CAMPO\n", nom);
    k += 2;
    recid();
    pvf1 = pvf;
    pvf = pva->apre;
    if (W)
      printf("BUSCARA EN SUBARBOL COM.CON %s\n", nom);
    if (strcmp(nom4, "PMESS")) {
      busidar1();
      if (!bva)
	error("invalid field name");
      pvf = pvf1;
    }
    sprintf(nom, "%s^.%s", nom4, strcpy(STR1, nom));
  }
  if (pva != NULL)   /*COR14.05.99*/
    strcpy(pva->typtyp, " ");
  if (W)
    printf("RECOGIDO %s\n", nom);

_L1: ;
}


/******************************************************** BUTANOD */
Void butanod()
{
  /* buscar en tabla de nodos lugar
                   en tabla subindice i */
  i = 1;
  bc = true;
  while (i <= n) {
    if (!strcmp(nod[i-1].nom, nom))
      goto _L4;
    i++;
  }

_L4:
  if (i <= n) {
    bc = false;   /* para busqueda desde clarec y bunod */
    if (W)
      printf("HALLADO NODO %s EN TABLA\n", nod[i-1].nom);
  } else {
    if (bn) {   /* para busqueda desde pronode */
      berr = true;
      goto _L1;
    }
    nod[i-1].il = 0;
    nod[i-1].el = 0;
  }
_L1: ;
}


/*******************************************************BUTAMESS*/
Void butamess()
{
  /*buscar y  agregar a lista de mensajes*/
  /*si no halla deja bmessfo=false y agrega al final; si halla
    deja apuntado por pmess y bmessfo=true*/
  pmess = pmessf;
  bmessfo = false;
  while (pmess != NULL && !bmessfo) {   /*buscar mensaje*/
    if (!strcmp(pmess->nom, nom))
      bmessfo = true;
    else {
      pmessa = pmess;
      pmess = pmess->ps;
    }
  }

  if (bmessfo)   /*si no se hallo agregarlo*/
    return;

  pmess = (lmess *)Malloc(sizeof(lmess));
  strcpy(pmess->nom, nom);
/* p2c: ug2.pas, line 297:
 * Note: Possible string truncation in assignment [145] */
  pmess->ps = NULL;
  if (pmessf == NULL)
    pmessf = pmess;
  else
    pmessa->ps = pmess;
}


/*P*/
/**********************************************************ERRCA***/
Void errca(chc)
Char chc;
{
  /*espera caracter chc*/
  Char STR1[12];

  if (ch != chc) {
    sprintf(STR1, "%c expected", chc);
    error(STR1);
  }
}


/********************************************************** ERROR */
Void error(mes)
Char *mes;
{
  printf("\nERROR %s lin: %d col %d\n\n", mes, lb, k);
  printf("(press Enter Enter to exit)\n\n");
  fputs(pl->con, stdout);
  /*LINUX gotoxy(k, wherey);*/
  UT = getchar();
  putchar('\n');
  berr = true;

  exit(1);

  /*cerrar los archivos abiertos*/
  /*31/10/1998*/
/*LINUX
  _SETIO(fprintf(modec, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modec != NULL)
      fclose(modec);
    modec = NULL;
  }
  _SETIO(fprintf(modini, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modini != NULL)
      fclose(modini);
    modini = NULL;
  }
  _SETIO(fprintf(modpro, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modpro != NULL)
      fclose(modpro);
    modpro = NULL;
  }
  _SETIO(fprintf(modaux, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modaux != NULL)
      fclose(modaux);
    modaux = NULL;
  }
  _SETIO(fprintf(modini1, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modini1 != NULL)
      fclose(modini1);
    modini1 = NULL;
  }
  _SETIO(fprintf(modedi, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modedi != NULL)
      fclose(modedi);
    modedi = NULL;
  }
  _SETIO(fprintf(modproc, " \n") >= 0, FileWriteError);
  if (P_ioresult != 0) {
    if (modproc != NULL)
      fclose(modproc);
    modproc = NULL;
  }
  _SETIO(fprintf(modnet, " \n") >= 0, FileWriteError);
  if (P_ioresult == 0)
    _Escape(1);


  if (modnet != NULL)
    fclose(modnet);
  modnet = NULL;
  _Escape(1);
LINUX fin*/
}


/******************************************************** WARNING */
Void warning(mes)
Char *mes;
{
  printf("\nWARNING %s lin: %d\n\n", mes, lb);
  fputs(pl->con, stdout);
  gotoxy(k, wherey);
  printf("\npress Enter to continue\n\n");
  UT = getchar();
  putchar('\n');
}


/******************************************************** VERFLIN */
Void verflin()
{
  if (W)
    printf("ENTRADA A VERFLIN LINEA %d %s k: %d \n", lb, pl->con, k);
  /* si es fin de linea reiniciar */
  /* transferir segun variable im */
  /*LINUX if (pl->con[k-1] != el)*/
  /*if (pl->con[k-1] != '\0')*/
/*PROB if(W) {
printf("k: %d  Len: %d con: %s\n",k,strlen(pl->con),pl->con); getchar();
} /*PROB*/
  if(k<=strlen(pl->con))
    goto _L1;
/*LINUX */ if(W) {puts("ve fin de linea"); getchar; }
/*3.10.2002 linux  pl->con[k-1] = ' '; pl->con[k]='\0';
  k++; */  
  if (btran && (!bprocp || bprovln)) {   /*28/3/1998*/
    /*si hay que transmitir texto y no estamos
                                 procesando proc. o func. PASCAL com.1998*/
    strsub(ren1, pl->con, ki, k - ki);   /*transmitir desde ki com.1998*/
    tranlin(ptra, true);
    limpbuf(ptra);
    ki = 1;
    if (bn && bnue && !bprocon) {   /*si es campo nuevo en nodo*/
      tranlin(5, false);
      limpbuf(5);
    }  /*poner en modaux*/
    goto _L2;
  }

  if (im == 1) {   /*procesando declaraciones*/
    if (W)
      printf("PROCESANDO DECLARACIONES ***\n");
    if (bmod && !bprocp && !dbase) {   /*transf.linea a modec*/
      ls++;
      fprintf(modec, "%s\n", pl->con);
    }
    if (bprocp) {   /*procesando PROC o FUNC pascal*/
      strsub(ren1, pl->con, ki, k - ki);
      tranlin(ptra, true);
      ki = 1;
      limpbuf(ptra);
      if (W) {
	printf("TRANSMITIDA LINEA DE PROCP O FUNCP\n");
	if (bencpf)
	  printf("SI ES ENC.VA TAMBIEN A INTERFACE\n");
      }
      if (bencpf)   /*enc.PROoFUN a interface*/
	tranlin(1, true);
    }
    if (bdeclr && bnuecam) {   /*campo nuevo en declar.de reg.g*/
      strsub(ren1, pl->con, mn, k - mn);
      mn = 1;
    }
  }

_L2:
  if (W)
    printf("LINEA TERM. LB %d %s\n", lb, pl->con);
  do {   /*mientras sea vacia*/
    pl = pl->pls;
    lb++;   /* ver linea siguiente */
    if (W)
      printf("LINEA SIG . LB %d %s\n", lb, pl->con);
    if (pl->con[0] == '$')
      error("unexpected end of program");
    k = 0;
    bbeg = true;   /* comienza nueva linea */
/*3.10.2002  } while (pl->con[0] == el);*/
  } while (strlen(pl->con) == 0);
  /*Delphi 9.2.2001 Si empieza con # se pasa sin analizar*/
  do {
    if (pl->con[0] == '#') {
      if (ptra != 1 || ModecCreado)   /*modec*/
      {  /*17.07.2002*/
        strsub(ren1, pl->con, 2, (int)(strlen(pl->con) - 1));   /*17.07.2002*/
        tranlin(ptra, false);
        limpbuf(ptra);   /*17.07.2002*/
      }  /*17.07.2002*/
      /*17.07.2002*/

      pl = pl->pls;
      lb++;   /* ver linea siguiente */
    }
  } while (pl->con[0] == '#');

_L1: ;
}


/*P*/
/********************************************************* ELICOM */
Void elicom()
{
  /* eliminar comentarios con  ( en k            */
  /* deja k despues de delimitador derecho no el */
  /* si de entrada es no delim. deja bcome=false */
  if ((pl->con[k-1] != '(' || pl->con[k] != '*') && pl->con[k-1] != '{') {
    bcome = false;
    return;
  }
  if (W)
    printf("COMIENZA A SALTAR COMENTARIO\n");
  switch (pl->con[k-1]) {

  case '(':
    k += 2;
    while (pl->con[k-1] != '*' || pl->con[k] != ')') {
      k++;
      verflin();
      if (k == 0)
	k = 1;
    }
    k += 2;   /* se recomienza en posicion siguiente al comentario */
    break;

  case '{':
    k++;
    while (pl->con[k-1] != '}') {
      k++;
      verflin();
      if (k == 0)
	k = 1;
    }
    k++;   /* se recomienza en posicion siguiente al comentario */
    break;
  }/* del case */
  verflin();
  if (k == 0)   /* salta linea si comentario acaba en 74 */
    k = 1;
}


Static Void eliblan()
{
  /* deja k en primero que no es blanco no el    */
  /* si de entrada es no blanco deja bblan=false */
  if (pl->con[k-1] != ' ') {
    bblan = false;
    return;
  }
  if (W)
    printf("VA A ELIMINAR BLANCOS\n");
  while (pl->con[k-1] == ' ') {
    k++;
    verflin();
    if (k == 0)
      k = 1;
  }
}


Local Void busdi()
{
  /* recoge cadena de digitos de pl^.con en nom */
  short kh;

  sprintf(nom + strlen(nom), "%c", ch);
  k++;
  ch = pl->con[k-1];
  kh = k;
  /*LINUX while ch in digit do begin nom:=nom+ch; k:=k+1; ch:=pl^.con[k] end;*/
  while (isdigit(ch)) {
    sprintf(nom + strlen(nom), "%c", ch);
    k++;
    ch = pl->con[k-1];
  }
  if (kh == k)
    bnumer = false;
}

Local Void busexp()
{
  /* recoger exponente */
  ch1 = pl->con[k];   /* ve lo que sigue a E */
  if (ch1 == '+' || ch1 == '-')
  {   /* recoger valor numerico del exponente; verificar!!!!!*/
    sprintf(nom + strlen(nom), "%c", ch);
    k++;
    ch = ch1;
  }
  busdi();
}


/******************************************************** RECCNUM */
Void reccnum()
{  /* proc. reccnum; retroceder, el comienzo esta en m */
  /* recoger constante numerica */
  k = m - 1;
  *nom = '\0';
  bent = true;
  bnumer = true;
  busdi();
  strdelete((Anyptr)nom, 1, 1);
  switch (ch) {

  case '.':
    if (pl->con[k] != '.') {
      bent = false;
      busdi();
      if (ch == 'E' || ch == 'e')
	busexp();
    }
    break;

  case 'E':
  case 'e':
    bent = false;
    busexp();
    break;
  }
  if (W)
    printf("RECOGIDO NUMERO %s CH %c\n", nom, ch);
}


/*P*/
/********************************************************* RECSTR */
Void recstr()
{
  /* recoger constante tipo str */
  boolean bfst = false;

  if (W)
    printf("RECOGIENDO CONSTANTE DE TIPO STRING\n");
  k++;   /*saltar el ' inicial; puede seguir ''*/
  /*recoge car.mientras no halle ' solo. Para si comienza linea */
  while ((pl->con[k-1] != '\'' || pl->con[k] == '\'') && k != 0) {
    if (pl->con[k-1] == '\'' && pl->con[k] == '\'') {   /*hallo '' */
      k += 2;
      if (W)
	printf("DOS APOSTR. SEGUIDOS %c%c\n", pl->con[k-1], pl->con[k]);
      verflin();
      continue;
    }

    if (W)
      putchar(pl->con[k-1]);
    k++;   /*pasar el caracter siguiente*/
    if (pl->con[k-1] == '\'')
      bfst = true;
    verflin();
  }


  if (k == 0 && !bfst)
    error("constant string exceeds the line");
  k++;   /* queda k despues del ' final */
  strcpy(tipo, "STRING");
  b = true;
  if (W) {
    putchar('\n');
    UT = getchar();
  }
}


/********************************************************* RECHAR */
Void rechar()
{
  /* recoger caracter */
  if (W)
    printf("RECHAR K=%d PL^.CON[K] %c\n", k, pl->con[k-1]);
  k++;
  ch2 = pl->con[k-1];
  k++;   /* pensando en avk1 */
  if (pl->con[k-1] != '\'')
    error("' expected");
  k++;
  strcpy(tipo, "CHAR");
}


/* a partir del caracter k de pl^.con busca la hilera de caracteres
 (eliminando blancos y buscando en lineas que siguen)
 y la pone en nom. Si es identificador pone b=true. En m queda
 posicion de comienzo, en k la de salida. El caracter que sigue al
 identificador queda en ch (puede ser blanco) se eliminan los
  comentarios precedentes. Los simbolos no
   identificadores detectados son
 ; = : ( ) [ ] , - + * / ^ blanco & < > =                           */
/*LINUX const separ:
 set of char=
 [' ',';','=',':','(',')','[',']',',','-','+','*','/', '^',
 '&','<','>','{','#','''','@','%','\'];*/


/*P*/
/********************************************************** RECID */
Void recid()
{
  static Char separ[24] = {
    ' ', ';', '=', ':', '(', ')', '[', ']', ',', '-', '+', '*', '/', '^', '&',
    '<', '>', '{', '#', '\'', '@', '%', '\\'
  };

  boolean sep = false;
  /*LINUX*/
  uchar isep;
  boolean chinsepar;

  if (W)
    printf("RECID pl^.con: %s \n",pl->con);
  bnumer = false;
  bent = false;
  verflin();
  if (k == 0)
    k = 1;
  *nom = '\0';
  ch = ' ';
  b = true;

  /*eliminar blancos y comentarios iniciales*/
  bcome = true;
  bblan = true;
  while (bcome || bblan) {
    bcome = true;
    bblan = true;
    eliblan();
    elicom();
  }

  /*recoleccion de identificador*/
  m = k;
  ch = pl->con[k-1];
  while (ch != el && !sep)
  {  /* parar si es separador o . en numerico o .. o . no de end.*/
    /*LINUX*/
    isep = 1;
    chinsepar = false;
    while (isep < 25 && !chinsepar) {
      if (ch == separ[isep-1])
	chinsepar = true;
      else
	isep++;
    }
    /*LINUX if (ch in separ)*/
    if (chinsepar || ch == '.' && isdigit(nom[0]) ||
	ch == '.' && pl->con[k] == '.' || ch == '.' && strcmp(nom, "END"))
    {   /*digito.*/
      sep = true;   /* parar busqueda !!!! dejar solo ultima condicion */
      break;
    }
    /*LINUX or ((ch='.') and  (nom[1] in digit))*/
    /*digito.*/
    /*escalar..  de array*/
    if (islower(ch))
      ch = toupper(ch);
    sprintf(nom + strlen(nom), "%c", ch);
    k++;
    ch = pl->con[k-1];
  }
  if (m == k)
    b = false;

  if (bbeg) {
    if (strcmp(nom, "NODE") && strcmp(nom, "STATISTICS") &&
	strcmp(nom, "NODEC"))
      bbeg = false;
  }

  /*LINUX if b and (nom[1] in digit) and ((pl^.con[k+1]<>'.') or (ch<>'.'))*/
  if (b && isdigit(nom[0]) && (pl->con[k] != '.' || ch != '.'))
  {   /* si comienza con digito y no sigue .. */
    reccnum();
    if (!bnumer) {
      error("error in number");
      berr = true;
    }
  } else {
    /*LINUX if b and (nom[1] in digit) and ((pl^.con[k+1]='.') and (ch='.'))*/
    if (b && isdigit(nom[0]) && pl->con[k] == '.' && ch == '.')
      bent = true;
  }
  /*ver caso n.. de subindices poner bent true (ver array)*/
  if (!b && ch == '\'')
    recstr();
_L1:
  if (W)
    printf("FIN RECID\n");
  if (W)
    printf("IDENT %s   CH %c  PL^.CON[K] %c\n", nom, ch, pl->con[k-1]);
}  /* fin del procedure recid */


/********************************************************** CLAREC */
Void clarec()
{
  /* clasificar nom recogido por recid; queda:kc=
   1:caracter;2:var.,3:separ.,4:nodo,5:func.val.,6:tabla,7:nada;
   caracter en ch; tipo de var en tipo */
  short IJJ;
  Char STR2[256];

  bc = true;
  kc = 0;
  *tipo = '\0';
  if (W)
    printf("CLASIFICAR LA VARIABLE %s (PROCESA %s )\n", nom, prog);
  while (bc) {
    kc++;
    switch (kc) {   /* si lo hallan pone bc=false */

    case 1:
      if (!b) {
	bc = false;
	strcpy(tipo, "CAR.");   /*detectar ciclo de car.invalido*/
	if (k == kant && lb == lbant)
	  error("illegal character");
	lbant = lb;
	kant = k;
      }
      break;

    case 2:
      busidar();   /*busca en arbol; si no halla, bc=true*/
      /* ver si es var.o proc o func. PASCAL o AAA^.CCC*/
      /*si es var. de prog. principal,proced.o func solo vale en estos*/
      /*en cada proc. que variables usa para verificar esto*/

      if (!bc)   /*si es o no de retardo*/
	ret = pva->ret;
      /*se hallo en arbol (bc false) y es tipo FUNP y no es FUNCTION
      o no es var.izquierda, entonces es llamada a func.Pascal del usuario*/

      if (!bc && !strcmp(tipo, "FUNP") && (!bfunp || !bprins)) {
	prfunp();
	bc = false;   /*por si prfunp lo puso true*/
      }

      /*ver si es campo DBASE*/
      if (pva != NULL && !bc && pva->dbase && bva) {   /*COR14.05.99*/
	tranhas(m, ptra);
	btran = false;
	IJJ = strpos2(nom, "_", 1);
	if (IJJ != 0)
	  sprintf(ren1, "%s.%.*s^",
		  strsub(STR2, nom, IJJ + 1, strlen(nom) - IJJ), IJJ - 1,
		  nom);
	else {
	  IJJ = strpos2(nom, ".", 1);
	  if (IJJ != 0)
	    sprintf(ren1, "%s^", nom);
	  else
	    error("invalid dbase variable");
	}
	tranlin(ptra, false);
	limpbuf(ptra);
	btran = true;
	ki = k;
	bc = false;
      }

      break;

    case 3:
      butasep();
      strcpy(tipo, "SEP");
      break;
      /* ver si es separador */

    case 4:
      butanod();
      strcpy(tipo, "NODO");
      break;

    case 5:
      butafun();
      strcpy(tipo, "FUNV");   /*puede ser definicion o llamada*/
      if (!bc) {
	if (ptra == 6)
	  kc = 28;
	else
	  prfunv();
      }
      break;
      /* ver si fun.val.apuntada:pfu */

    case 6:
      bulitab(true);
      strcpy(tipo, "TABLA");
      break;
      /* ver si es tabla */

    case 7:
      if (*nom == '\0') {
	bc = false;
	strcpy(tipo, nom);
/* p2c: ug2.pas, line 642:
 * Note: Possible string truncation in assignment [145] */
      }  /*!!!!!!!*/
      break;

    case 8:
      if (!strcmp(nom, "TSIM")) {
	bc = false;
	bg = true;
	dime = 0;
	strcpy(tipo, "REAL");
	stvname(true, nom);   /* TSIM a arbol */
	strcpy(tipo, nom);
/* p2c: ug2.pas, line 645:
 * Note: Possible string truncation in assignment [145] */
	strcpy(nom4, "TSIM");
	bg = false;
      }
      break;

    case 9:
      butainc();
      strcpy(tipo, "INS.ESTR.");
      break;
      /* es IF,FOR,..,DONODE,etc.*/

    case 10:
      if (!strcmp(nom, "END")) {
	bc = false;
	strcpy(tipo, nom);
/* p2c: ug2.pas, line 648:
 * Note: Possible string truncation in assignment [145] */
      }
      break;

    case 11:
      if (bnumer) {
	bc = false;
	strcpy(tipo, "NUMERO");
      }
      break;

    case 12:
      if (!strcmp(nom, "TRUE") || !strcmp(nom, "FALSE")) {
	bc = false;
	strcpy(tipo, "CONST.LOG");
      }
      break;

    case 13:
      if (!strcmp(nom, "UNTIL")) {
	bc = false;
	strcpy(tipo, nom);
/* p2c: ug2.pas, line 653:
 * Note: Possible string truncation in assignment [145] */
      }
      break;

    case 14:
      if (!strcmp(nom, "IT") || !strcmp(nom, "NT")) {
	bc = false;
	strcpy(tipo, nom);
/* p2c: ug2.pas, line 654:
 * Note: Possible string truncation in assignment [145] */
      }
      break;

    case 15:
      butapro();
      strcpy(tipo, "PROCG");
      break;
      /* queda posicion en ij */

    case 16:
      bufugli();
      strcpy(tipo, "FUNPG");   /* funcion G o P pos en ij */
      if (!bc)
	prfunpg();
      break;

    case 17:
      buprwr();
      strcpy(tipo, "PRWR");
      break;
      /* proc.WRITE o READ LN, FILE*/

    case 18:
      if (!strcmp(nom, "EXPER")) {
	bc = false;
	strcpy(tipo, "EXP.");
      }
      break;

    case 19:
      if (!strcmp(nom, "ENDEXP")) {
	bc = false;
	strcpy(tipo, "ENDEXP.");
      }
      break;

    case 21:
      butaprop();
      strcpy(tipo, "PROPA");
      break;
      /*proc.PASCAL*/

    case 23:   /*proc. RAND f.prob.multiple*/
      if (!strcmp(nom, "RAND"))
	bc = false;
      break;

    case 26:
      if (!strcmp(nom, "REPORT")) {
	bc = false;
	strcpy(tipo, "REPORT");
      }
      break;

    case 27:
      if (!strcmp(nom, "ENDREPORT")) {
	bc = false;
	strcpy(tipo, "ENDREPORT");
      }
      break;

    case 29:
      error("unknown  identifier");
      break;

    }/* del case */
  }  /* del while bc */
  if (W)
    printf("KC=%d %s  ES DE TIPO %s\n", kc, nom, tipo);
}  /* de clarec */


/********************************************************* VERSPAR */
Void verspar(nusub)
short nusub;
{
  /* ver si hay parentesis [], procesarlo */
  short contsu = 0;   /*ojo recursiva!!*/

  if (W) {
    printf("ENTRA A VER PARENTESIS\n");
    UT = getchar();
  }
  /*recid;*/
  k++;
  /* absorber  el supuesto [ */
  /*kc1:=kc;*/
  brepar = true;
  if (b || ch != '[')
    error("[ expected");
  while (ch != ']') {
    if (W) {
      printf("A RECOGER %d  SUBINDICES\n", nusub);
      UT = getchar();
    }
    recexpr();
    if (ch != ']' && ch != ',')
      error("] or , expected");
    contsu++;
  }
  /*ANULADO PARA PERMITIR SUBINDICES EN CAMPOS VER RECEXPR*/
  /*if contsu<>nusub then error('incorrect number of subscripts'); */

  /*ver si al ] le sigue campo de record*/
  if (pl->con[k-1] == '.') {
    k++;
    recid();
  }

  /*if pl^.con[k]=',' then*/
  brepar = false;
  /*15/10/1996*/
  /* kc:=kc1; k:=k+1;*/
  b = true;   /* no busq.unario */
}


/********************************************************* PROESVA */
Void proesva()
{
  /* gen. procesado anterior de est. de var */
  if (W) {
    printf("PROC. EST.ANTERIOR A VARIABLE\n");
    UT = getchar();
  }
  bestv = true;
  tranhas(m - 1, ptra);
  btran = false;
  strcpy(nome, nom);   /* guardar identific.*/
  strcpy(nom4, nom);   /* por si es experimental (ver prinsim)  */
  recid();   /* ver que sigue a identificador  : o [ */
  *cindes = '\0';
  indn = 0;
  if (ch == '[') {
    k++;
    recid();   /* recoger subin. simple */
    sprintf(nome + strlen(nome), "[%s]", nom);
	/* formar variable con indice */
    if (bnumer && bent)
      esnum = (sscanf(nom, "%d", &indn) == 0);
    else {
      strcpy(cindes, nom);
/* p2c: ug2.pas, line 712:
 * Note: Possible string truncation in assignment [145] */
    }
    recid();
    if (ch != ']')
      error("error in subscripted variable with statistics");
    k++;   /*ver que sigue a ] , debe ser :  */
    recid();
  }

  if (pva->ind == 1) {
    sprintf(invae, "%d", pva->nvl);
/* p2c: ug2.pas, line 719:
 * Note: Possible string truncation in assignment [145] */
    strcpy(cindes, invae);
/* p2c: ug2.pas, line 719:
 * Note: Possible string truncation in assignment [145] */
  } else {
    sprintf(invae, "%d", pva->nvl + indn - 1);
/* p2c: ug2.pas, line 720:
 * Note: Possible string truncation in assignment [145] */
    sprintf(cindes + strlen(cindes), "+%s", invae);
/* p2c: ug2.pas, line 722:
 * Note: Possible string truncation in assignment [145] */
  }
  strcpy(ren1, fosa[19]);
  tranlin(ptra, true);   /* poner begin */
  if (!binit) {
    sprintf(ren1, "_prsta(%s,%s); ", cindes, nome);
    tranlin(ptra, true);
  }

  strcpy(ren1, nome);
  tranlin(ptra, true);   /*poner miembro izq. de asignacion*/
  ki = k;
  strcpy(nom, nom4);   /* por si es exp */
  btran = true;
}


/********************************************************* PROESVP */
Void proesvp()
{  /*k quedo despues de lo que sigue a <expresion> */
  /* gen.procesado posterior de est. de var */
  if (W) {
    printf("PROC. EST.POSTERIOR A VARIABLE\n");
    UT = getchar();
  }
  if (!strcmp(nom, "ELSE") || !strcmp(nom, "END")) {
    tranhas(m, ptra);
    ki = m;
    strcpy(ren1, ";");
    tranlin(ptra, false);
  } else {
    tranhas(k, ptra);
    ki = k + 1;
  }

  /* inser(fosa[163],'.',cindes,ren1,0); inser(ren1,'/',nome,ren1,0);
  tranlin(ptra,true);    (* if var> _hv etc. *)
  inser(fosa[164],'.',cindes,ren1,0); inser(ren1,'/',nome,ren1,0);
  tranlin(ptra,false);   (* if var< _hv etc *)
  inser(fosa[165],'.',cindes,ren1,0);tranlin(ptra,true);(*act.h.ult.camb*)
  (*actualizar _svv,_s2vv*,_sva*)
  inser(fosa[484],'.',cindes,ren1,0); inser(ren1,'%',nome,ren1,0);
  tranlin(ptra,true);
  inser(fosa[485],'.',cindes,ren1,0); inser(ren1,'%',nome,ren1,0);
  */
  sprintf(ren1, "_prstp(%s,%s);", cindes, nome);
  tranlin(ptra, true);
  if (!strcmp(nom, "ELSE") || !strcmp(nom, "END"))
    strcpy(ren1, fosa[29]);
  else
    strcpy(ren1, fosa[20]);
  tranlin(ptra, true);
  limpbuf(ptra);
}


/***************************recexpr nuevo**********************/
/********************************************************* RECEXPR */
Void recexpr()
{
  /* recoge expresion o var.de comienzo instr. */
  boolean badd = true;
  boolean bmult;

  /* comienza proc. recexpr   *****/
  if (W)
    printf("SE BUSCA EXPRESION\n");
  if (lb >= lbf) {
    printf("PASADO DE LINEA****\n");
    UT = getchar();
    goto _L1;
  }

  while (badd) {   /* repetir mientras haya aditivos */
    bmult = true;   /* recoger termino */
    while (bmult) {  /*recoger factor*/
      recid();   /*recoge identificador o simbolo*******************/

      if (lb >= lbf)   /***********VER****************/
	goto _L1;
      /*recoge unario o variable o ( */
      if (W)
	printf("FACTOR COMENZADO POR %s     SIGUE %c\n", nom, ch);
      if (b && !strcmp(nom, "NOT")) {   /* unario de expr.logica */
	ch = '-';
	b = false;   /*se espera exp.booleana*/
      }  /* exp logica */

      clarec();
      /* clasificar identificador recogido procesa asig a nodo
                 y fun. pascal tipo queda en tivr */
      if (!strcmp(tipo, "ARRAY")) {
	recid();
	verspar(pva->dim);
	b = true;
      }  /*es tipo arreglo predef.*/
      else {
	if (pva != NULL && !strcmp(pva->typtyp, "ARRAY")) {
	      /*MARTA 25.10.99*/
		recid();   /*puede no tener [] en llamado a proc.pas*/
	  if (ch == '[')
	    verspar(pva->dim);
	  else if (!bfunpg)
	    errca('[');
	  b = true;
	}
	/*es tipo declarado tipo arreglo*/
      }
      /*PROV. PARA PERMITIR SUBINDICES EN CAMPOS*/
      if (ch == '[') {
	b = false;
	verspar(pva->dim);
      }

      if (!strcmp(tipo, "STRING")) {   /*si es STRING puede tener [] */
	recid();
	if (ch == '[')
	  verspar(1);
	else
	  b = true;
      }  /*restaura b*/

      if (!b) {   /*no se recogio identificador*/
	switch (ch) {

	case '+':
	case '-':
	  k++;
	  recid();   /* rec. lo que sigue a unario  ( o var */
	  clarec();
	  if (!strcmp(tipo, "ARRAY")) {
	    recid();
	    verspar(pva->dim);
	    b = true;
	  }  /*es tip arr predef.*/
	  else {
	    if (pva != NULL && !strcmp(pva->typtyp, "ARRAY"))
	    {   /*MARTA 25.10.99*/
	      recid();   /*puede no tener [] en llamado a proc.pas*/
	      if (ch == '[')
		verspar(pva->dim);
	      else if (!bfunpg)
		errca('[');
	      b = true;
	    }
	    /*es tipo declarado tipo arreglo*/
	  }

	  if (ch == '(') {   /* es unario seguido de ( */
	    k++;
	    par++;
	    recexpr();
	    if (ch != ')')
	      error(") expected");
	    else
	      par--;
	  }  /* factor parentizado  */
	  break;

	/*OJO*/
	case '(':
	  k++;
	  par++;
	  recexpr();   /*** !! repetido */
	  if (ch != ')')
	    error(") expected");
	  else
	    par--;
	  break;
	  /* factor parentizado  */

	case '\'':   /* recogerla */
	  /* constante string */
	  recstr();
	  break;

	default:
	  error("illegal term");
	  break;
	}/* fin del case ch */
      }
      /* es unario + -  o  es ( '  */
      else {
	switch (kc) {

	case 2:
	case 5:
	case 7:
	case 11:
	case 12:
	case 16:
	  /* blank case */
	  break;

	default:
	  error("variable, function or constant expected");
	  break;
	}
      }

      if (W) {
	printf("VER SIG A VAR. O FAC.PL^.CON[K] %c\n", pl->con[k-1]);
	UT = getchar();
      }
      recid();   /* rec.lo sig. a variable o factor */
      if (b) {  /* factor seguido por nombre tal vez separador      */
	i = 0;
	butasep();
	switch (i) {
	    /* end or and then else do to downto of mod not div xor */

	case 1:
	case 4:
	case 5:
	case 6:
	case 7:
	case 8:
	case 9:
	case 11:
	  ch = ';';
	  k--;
	  break;

	case 2:
	case 13:
	case 14:   /* OR XOR IN*/
	  ch = '+';
	  break;
	  /*el IN provisorio aqui*/

	case 3:   /* AND */
	  ch = '*';
	  break;

	case 12:   /*DIV*/
	  ch = '/';
	  break;

	case 10:   /*MOD*/
	  ch = '+';
	  break;

	default:
	  error("invalid character following factor or missing separator");
	  break;
	}/* del case i */
      }
      switch (ch) {   /* ver si siguen factores mult. o terminan */

      case '/':
      case '*':   /* buscar factor siguiente */
	k++;
	break;

      default:   /* fin factores, puede ser + - ; < > = */
	bmult = false;
	break;
      }/* del case */
    }  /* fin del while bmult, recogio termino y lo que sigue */


    k++;
    badd = false;   /* saltar lo que sigue a separador de expr.*/
    switch (ch) {   /* ver que sigue al termino,ojo! k despues de ch */

    case '+':
    case '-':   /* para seguir recogiendo terminos */
      badd = true;
      break;

    case ')':   /* salida de recursion hubo (  */
      break;

    case ';':
      /* blank case */
      break;

    case '=':
      recexpr();
      break;

    /* si es ) end ; = salida de la recursion.Si sigue ; saltarlo*/
    case '<':
      if (pl->con[k-1] == '>' || pl->con[k-1] == '=')
	k++;
      recexpr();
      break;

    case '>':
      if (pl->con[k-1] == '=')
	k++;
      recexpr();
      break;

    case ']':   /* salida de identificador con [] */
      break;

    case ',':
      if (!bfunpg && !brepar && !brewr && !bactiv) {   /*1997*/
	/*si no esta en func.proc.o [,] o READ WRITE FILE*/
	error("illegal  ,  after expression");
      }
      break;

    /* , debe ser separador de argumentos */
    case ':':   /* : de formato  o de var[ ]:= */
      break;

    default:
      error("in expression");
      break;
    }
    if (W)
      printf("SE RECOGIO TERMINO\n");
  }  /* fin del while badd,recogido termino */

  if (W) {
    printf("RECOGIDA EXPRESION TERMINADA CON CH %c  NOM %s\n", ch, nom);
    UT = getchar();
  }
  goto _L1;

_L2:
  if (begend != 0) {
    printf("VER NODO  %s\n", nod[jn_-1].nom);
    error("BEGIN END do not match");
  }

_L1: ;
}  /* de recexpr  */


/*******************************************************  BUTASEP */
Void butasep()
{
  /* busca separador:END,OR,AND,THEN,ELSE,DO,TO,DOWNTO
      OF,MOD,NOT,DIV,XOR, si halla pone bc=false, y tipo en tabnoms[i] */
  i = 1;
  while (strcmp(nom, tabnoms[i-1]) && i < 15)
    i++;
  if (i < 15)
    bc = false;
}


/******************************************************** BUTAINC */
Void butainc()
{
  /* ver si es instr.comp.,if,while, etc. num.en r */
  r = 1;
  while (r < 11 && strcmp(tabin[r-1], nom))
    r++;
  if (r < 11)
    bc = false;
}


/******************************************************** BUTAFUN */
Void butafun()
{
  /* busca funciones valuadas las apunta por pfu */
  if (W)
    printf("BUSCA FUNCION VALUADA\n");
  pfu = pfuf;
  while (pfu != NULL && bc) {
    pfuan = pfu;
    if (strcmp(pfu->nom, nom))
      pfu = pfu->pfus;
    else
      bc = false;
  }
}  /******************************************/


/******************************************************** BUTAPRO */
Void butapro()
{  /*BINARIA !!!!!!!!!!*/
  /*busca en tabla de procedimientos G */
  if (W)
    printf("BUSCA %s EN TABLA INST.Y PROC.GLIDER\n", nom);
  ij = 1;
  while (ij <= 59 && strcmp(stgli[ij-1], nom)) {
    if (W)
      printf("%d %s", ij, stgli[ij-1]);
    ij++;
  }
  if (ij <= 59)
    bc = false;
}


/******************************************************** BUTAPROP */
Void butaprop()
{  /*BINARIA !!!!!!!!!!*/
  /*busca en tabla de procedimientos P */
  if (W)
    printf("BUSCA %s EN TABLA PROC.PASCAL\n", nom);
  ij = 1;
  while (ij <= 27 && strcmp(tapropa[ij-1], nom))
    ij++;
  if (ij <= 27)
    bc = false;
}


/******************************************************** BUFUGLI */
Void bufugli()
{  /*BINARIA !!!!!!!!!!*/
  /*busca en tabla de funciones G o P */
  if (W)
    printf("BUSCAR FUNCION G o P %s\n", nom);
  ij = 1;
  while (ij <= 56 && strcmp(fugli[ij-1], nom))
    ij++;
  if (ij <= 56)
    bc = false;
}


/******************************************************** BUTATAB */
Void bulitab(tab)
boolean tab;
{  /* si param. tab true busca por nom.tabla sino  por variable*/
  /* busca en lista de tablas deja apuntado por plt*/
  plt = pltf;
  bc = true;
  r = 0;
  while (bc && plt != NULL) {
    if (tab) {
      if (!strcmp(plt->t, nom))
	bc = false;
      else
	plt = plt->p;
    } else if (!strcmp(plt->v, nom))
      bc = false;
    else
      plt = plt->p;
    r++;   /* numero de tabla */
  }

}


/******************************************************** BULITIP */
Void bulitip()
{  /* si lo halla queda bc false; queda apuntado por ptyp*/
  /* busca en lista de tipos deja apuntado por ptyp*/
  ptyp = ptypf;
  bc = true;
  l = 1;
  while (bc && ptyp != NULL) {
    if (W)
      printf(" %s", ptyp->nom);
    if (!strcmp(ptyp->nom, nom))
      bc = false;
    else {
      ptyp = ptyp->ps;
      l++;
    }
  }
  if (W)
    putchar('\n');
  if (W) {
    if (bc)
      printf("NO HALLADO\n");
    else
      printf("HALLADO TIPO %s\n", ptyp->nom);
  }
  if (W)
    UT = getchar();
}


/********************************************************AGRTYP****/
Void agrtyp(s, tipo)
Char *s, *tipo;
{
  /*agrega a lista de tipos el s de tipo
                                  tipo y lo apunta por ptyp y ptypa*/
  if (W)
    printf("AGREGAnDO A LISTA DE TIPOS EL %s DE TIPO %s\n", s, tipo);
  ptyp = (typ *)Malloc(sizeof(typ));
  strcpy(ptyp->nom, s);
  ptypa->ps = ptyp;   /*EL ANTERIOR LO APUNTA*/
  ptypa = ptyp;
  ptyp->ps = NULL;
  ptypl = ptyp;
  strcpy(ptyp->tipo, tipo);
  ptyp->apind = apind;
  ptyp->nsub = dime;
  strcpy(ptyp->typel, typel);   /*18/10/1998*/
  if (W)
    printf("AGREGADO A LISTA DE TIPOS EL %s DE TIPO %s TIPO DE ELEMENTO %s\n",
	   ptyp->nom, ptyp->tipo, ptyp->typel);

}


/********************************************************* BUPRWR */
Void buprwr()
{  /*BINARIA !!!!!!!!!!*/
  /* busca en tabla de procedimientos W o R */
  ij = 1;
  while (ij <= 5 && strcmp(taprwr[ij-1], nom))
    ij++;
  if (ij <= 5)
    bc = false;
}


/********************************************************BUTACOL*/
Void butacol()
{
  /*busca nom en tabla de colores*/
  ij = 1;
  while (ij <= 17 && strcmp(tabcolo[ij-1], nom))
    ij++;
  if (ij > 17)
    error("erroneous color name");
}


/********************************************************* RESUNO */
Void resuno()
{  /* subin en nom2,su valor en vind ,k queda despues de  ] */
  /* recoger subin. de nodo con nombre en nom1 */
  Char STR1[102];

  recid();
  if (ch != '[')
    error("[ missing in node");
  k++;
  recid();
  strcpy(nom2, nom);
  esnum = (sscanf(nom2, "%d", &vind) == 0);
      /* si es numerico queda esnum=0 */
  if (esnum != 0 && strcmp(nom, "MIN") && strcmp(nom, "FREE")) {
    busidar();
    if (!bva) {
      sprintf(STR1, "unknown identifier %s", nom);
      error(STR1);
    }
    if (!strcmp(tipo, "INTEGER") || !strcmp(tipo, "WORD"))
      binte = true;
    else
      error("integer identifier expected");
  }
  if (esnum == 0) {
    if (vind > nod[i-1].sub)
      error("subscript value exceeded");
  }
  if (strcmp(nom, "MIN") && strcmp(nom, "FREE"))
    sprintf(nom1 + strlen(nom1), "[%s]", nom);
  recid();
  if (b || ch != ']')
    error("invalid subscript");
  k++;
}


/*********************************************************** RENO */
Void reno(bno)
boolean bno;
{   /* si bno=true y no es nodo da error; si es nodo bc=false */
  /* recoger nodo,deja nombre en nom1 */
  bc = true;
  strcpy(nom2, "1");   /*subin.tentativamente a 1 */
  recid();
  butanod();
  if (bc) {
    if (bno != true)
      goto _L1;
    error("node expected");
  }
  strcpy(nom1, nom);   /* si es SELECT terminar */
  sprintf(nic, "%d", i);
/* p2c: ug2.pas, line 1039:
 * Note: Possible string truncation in assignment [145] */
  sprintf(tipon, "%c", nod[i-1].tipo);
  if (nod[i-1].sub != 1)
    resuno();
_L1: ;
}


/******************************************************** PRFUNPG */
Void prfunpg()
{
  /* procesar funcion P o G */
  short ik = 0;
  short nump, ijr;
  boolean bfun;   /* van aqui por llamada recursiva */

  if (W) {
    printf("FUNCION P O G %s\n", nom);
    UT = getchar();
  }
  ijr = ij;
  strcpy(nomfunpg, nom);
/* p2c: ug2.pas, line 1047:
 * Note: Possible string truncation in assignment [145] */
  bfun = bfunpg;
  if (nupar[ijr-1] >= 0) {  /* funcion con parametros expresiones */
    nump = nupar[ijr-1];
    if (nump > 0) {
      bfunpg = true;
      recid();
      if (ch != '(')
	error("( missing in function");
      k++;
      while (ch != ')' && ik < nump) {
	recexpr();   /***/
	ik++;
      }
      if (ijr <= 15) {   /*es aleatoria */
	if (ch == ',') {  /* debe seguir parametro numerico de semilla */
	  recid();
	  if (!bent)
	    error("integer or ) expected");
	  numpr = (sscanf(nom, "%d", &numse) == 0);
	  if (numse < 1 || numse > 10)
	    error("invalid seed number");
	  recid();
	  k++;
	}


	else {
	  tranhas(k - 1, ptra);
	  strcpy(ren1, ",1)");
	  tranlin(ptra, false);
	  ki = k;
	}
      }


      /* falta semilla poner ,1 */
      if (ch != ')')
	error("missing ) or erroneous number of parameters");
      bfunpg = bfun;
    }



    if (ik != nump)
      error("erroneous number of parameters");
  }


  else {
    tranhas(m, ptra);
    btran = false;
    strcpy(nom5, nom);
    recid();
    if (ch != '(')
      error("( missing in function");
    k++;
    busli(ren3);   /* hallar numero de la lista */
    if (!strcmp(nom5, "L"))
      strcpy(ren1, "_l[.]");
    else if (!strcmp(nom5, "LL"))
      strcpy(ren1, "_l^[.]");
    else if (!strcmp(nom5, "MAXL"))
      strcpy(ren1, "_lm^[.]");
    else if (!strcmp(nom5, "MINL"))
      strcpy(ren1, "_[.]");   /****!!!!!!!!!!!!***/
    else if (!strcmp(nom5, "MEDL"))
      strcpy(ren1, "_lp^[.]");
    else if (!strcmp(nom5, "DMEDL"))
      strcpy(ren1, "_de^[.]");
    else if (!strcmp(nom5, "ENTR"))
      strcpy(ren1, "_en^[.]");
    else if (!strcmp(nom5, "TFREE"))
      strcpy(ren1, "_tl^[.]");
    else if (!strcmp(nom5, "MSTL"))
      strcpy(ren1, "_tpp^[.]");
    else if (!strcmp(nom5, "DMSTL"))
      strcpy(ren1, "_dp^[.]");
    else if (!strcmp(nom5, "PLAST"))
      strcpy(ren1, "_ll[.]");   /*05291996*/
    else if (!strcmp(nom5, "PFIRST"))
      strcpy(ren1, "_fl[.]");
    /*05291996*/

    inser(ren1, '.', ren3, ren1, 0);
    tranlin(ptra, false);
    recid();   /* recoger ) */
    if (ch != ')')
      error(") expected in function");
    k++;
    ki = k;
  }
  /* funcion con parametros IL_ o EL_ */

  /* del if de parametros nodos */
  if (W) {
    printf("PROCESADA FUNCION P O G\n");
    UT = getchar();
  }

  b = true;
  btran = true;
  strcpy(nomfunpg, " ");
}


/********************************************************* PRFUNP */
Void prfunp()
{
  /* procesar funcion PASCAL del usuario*/
  short ik, nump;   /* van aqui por llamada recursiva */

  if (W) {
    printf("FUNCION PASCAL DEL USUARIO %s\n", nom);
    UT = getchar();
  }
  strcpy(nomfunpg, nom);   /*para distinguir que funcion se esta procesando*/
/* p2c: ug2.pas, line 1121:
 * Note: Possible string truncation in assignment [145] */
  nump = pva->npar;
  if (nump > 0) {
    ik = 0;
    recid();
    bfunpg = true;
    if (ch != '(')
      error("( missing in function");
    k++;
    while (ch != ')' && ik < nump) {
      recexpr();
      ik++;
    }
    if (ch != ')')
      error(") missing or erroneous number of parameters");
    b = true;   /*"recogido identificador" */
    if (W) {
      printf("NOMFUNPG %s\n", nomfunpg);
      UT = getchar();
    }
    bfunpg = false;
  }
  strcpy(nomfunpg, " ");
}


/********************************************************* PRFUNV */
Void prfunv()
{  /* se esta procesando expresion gener. llamada a _f...*/
  /* procesar funcion valuada en expresion */
  st10 clafun, nomfun, argfun, mfufun;   /* necesarios por butafun */
  short guarnuspl;

  if (W) {
    printf("PROCESAR FUNCION VALUADA EN EXPRESION\n");
    UT = getchar();
  }
  tranhas(m, ptra);
  btran = false;
  strcpy(clafun, pfu->cla);
  strcpy(nomfun, pfu->nom);
  strcpy(argfun, pfu->arg);
  strcpy(mfufun, pfu->mfu);
  /*recid;*/
  /* ver que sigue a nombre de gfuncion ( o ; */
  sprintf(ren3, "%s%s%s", clafun, argfun, mfufun);   /*_fclaseargumvalor*/
  inser(fosa[108], '@', ren3, ren1, 0);
  tranlin(ptra, false);
  if (strcmp(clafun, "FREQ")) {  /*********VER SPLINE Y PONERLE NUMERO*/
    recid();
    if (ch != '(')
      error("( expected");
    k++;
    ki = k;
    btran = true;
    if (!strcmp(clafun, "SPLINE"))   /*por i se pierde*/
      guarnuspl = pfu->nfspl;
    recexpr();
    b = true;
    tranhas(k - 1, ptra);
    ki = k;   /* tr. argumento */
    if (ch != ')')
      error(") expected");
    inser(fosa[109], '@', nomfun, ren1, 0);
    if (!strcmp(clafun, "SPLINE")) {
      sprintf(cnfspl, "%d", guarnuspl);
/* p2c: ug2.pas, line 1161:
 * Note: Possible string truncation in assignment [145] */
      sprintf(ren1 + strlen(ren1), ",%s", cnfspl);
    }
    strcat(ren1, ")");
    tranlin(ptra, false);
    b = true;   /*recogido identificador*/
  } else {
    inser(fosa[299], '&', nomfun, ren1, 0);   /*  (_xNOM,_yNOM,_nNOM,  */
    tranlin(ptra, false);
    limpbuf(ptra);
    recid();   /*ver que sigue ( num.corr.aleat  ) END ELSE ; etc.*/
    if (ch == '(') {   /*espera corriente de numeros aleatorios*/
      k++;
      recid();
      if (bent == false)
	error("number expected");
      /*verificar!!!!!!!!!!!!!!<=10*/
      sprintf(ren1, "%s)", nom);   /*poner numero de corriente y ) cierre*/
      tranlin(ptra, false);
      recid();
      if (ch != ')')
	error(") expected");
      k++;
      b = true;
    } else {   /* tran. nr o 1)  */
      strcpy(ren1, "1)");   /*corriente de defecto 1 */
      tranlin(ptra, false);
      if (b)
	k = m - 1;
      else
	b = true;
    }
  }
  /* es FREQ */
  ki = k;
  btran = true;
}


/********************************************************PRFUNVA*/
Void prfunva()
{  /* funcion valuada apuntada por pfu */
  /*procesar funcion valuada en INIT*/
  Char STR1[84];

  if (W) {
    printf("PROCESAR FUNCION VALUADA EN INIT\n");
    UT = getchar();
  }
  if (ptra != 6)
    error("illegal use of function");
  /* se esta procesando INIT generar const. y decl.array */
  tranhas(m, 6);   /* transferir lo anterior  a modini1 */
  strcpy(ren1, "const ");
  tranlin(3, true);
  im = 2;
  btran = false;
  recid();   /* ver que sigue a nombre de funcion */
  if (b || ch != ':' || pl->con[k] != '=')
    error(":= expected");
  k += 2;
  ptxf = NULL;
  while (ch != ';') {   /* buscar puntos */
    if (W) {
      printf("RECOGIENDO PUNTOS\n");
      scanf("%c%*[^\n]", &UT);
      getchar();
    }
    ptx = (recx *)Malloc(sizeof(recx));
    pty = (recy *)Malloc(sizeof(recy));
    if (ptxf == NULL) {
      ptxf = ptx;
      ptyf = pty;
      npun = 0;
    } else {
      ptxa->ps = ptx;
      ptya->ps = pty;
    }
    npun++;
    /*!!!!!!!!!! procedimiento */
    recid();   /* recoger signo o valor de x ******** verificarlo ***/
    if (!b) {
      if (ch == '-' || ch == '+') {
	k++;
	ch3 = ch;
	recid();
	if (bnumer)
	  sprintf(nom, "%c%s", ch3, strcpy(STR1, nom));
	else
	  error("number expected");
      }
    }

    if (strcmp(pfu->cla, "DISC") && strcmp(pfu->cla, "FREQ")) {
      esnum = (sscanf(nom, "%lg", &nux) == 0);
      if (esnum != 0)
	error("error in number");
      if (npun > 1) {
	if (nuxa > nux)
	  error("argument values not in order");
      }
      nuxa = nux;
    }
    /* verificar secuencia */
    strcpy(ptx->val, nom);
/* p2c: ug2.pas, line 1224:
 * Note: Possible string truncation in assignment [145] */
    ptx->ps = NULL;
    recid();
    if (ch != ',')
      error("Y value expected");
    k++;
    recid();   /* recoger signo o valor de y ******** verificarlo ***/
    if (!b) {
      if (ch == '-' || ch == '+') {
	k++;
	ch3 = ch;
	recid();
	if (bnumer)
	  sprintf(nom, "%c%s", ch3, strcpy(STR1, nom));
	else
	  error("number expected");
      }
    }
    if (!strcmp(pfu->cla, "FREQ")) {
      esnum = (sscanf(nom, "%lg", &nuy) == 0);
      if (esnum != 0)
	error("error in value of frequency");
      if (npun > 1)
	nuya = nuy + nuya;
      else
	nuya = nuy;
      sprintf(nom, "% .5E", nuya);
    }
    /* acumular frecuencias */
    strcpy(pty->val, nom);
/* p2c: ug2.pas, line 1241:
 * Note: Possible string truncation in assignment [145] */
    pty->ps = NULL;
    recid();
    if (ch != '/' && ch != ';')
      error("/ o ; expected");
    k++;
    ptxa = ptx;
    ptya = pty;
    if (W) {
      printf("VALORES RECOGIDOS X %s  Y %s\n", ptx->val, pty->val);
      UT = getchar();
    }
  }  /* del while que busca puntos */

  if (pfu->np < npun)
    error("incorrect number of values");
  pfu->btafu = true;   /* anotar que hay tabla de esta funcion */
  sprintf(snpun, "%d", npun);   /* generar constantes */
/* p2c: ug2.pas, line 1253:
 * Note: Possible string truncation in assignment [145] */
  inser(fosa[95], '@', pfu->nom, ren1, 0);   /* nombre de const */
  inser(ren1, '*', pfu->arg, ren1, 0);
  inser(ren1, '/', snpun, ren1, 0);
  tranlin(3, false);
  ptx = ptxf;
  while (ptx != NULL) {
    if (ptx->ps == NULL)
      strcpy(sfc, "); ");
    else
      strcpy(sfc, ",");
    sprintf(ren1, "%s%s", ptx->val, sfc);
    tranlin(3, false);
    ptx = ptx->ps;
  }
  inser(fosa[96], '@', pfu->nom, ren1, 0);   /* nombre de const */
  inser(ren1, '&', pfu->mfu, ren1, 0);
  inser(ren1, '/', snpun, ren1, 0);
  tranlin(3, false);
  pty = ptyf;
  while (pty != NULL) {
    if (pty->ps == NULL)
      strcpy(sfc, "); ");
    else
      strcpy(sfc, ",");
    sprintf(ren1, "%s%s", pty->val, sfc);
    tranlin(3, false);
    pty = pty->ps;
  }
  if (primef) {   /*la primera vez transmitir los new(_spb); etc */
    primef = false;
    strcpy(ren1, fosa[343]);
    tranlin(6, true);
  }
  if (!strcmp(pfu->arg, "REAL")) {
    sprintf(ren1, "new(_x%s);", pfu->nom);
    tranlin(6, true);
  } else {
    sprintf(ren1, "new(_xa%s);", pfu->nom);
    tranlin(6, true);
  }
  if (!strcmp(pfu->mfu, "REAL")) {
    sprintf(ren1, "new(_y%s);", pfu->nom);
    tranlin(6, true);
  }

  inser(fosa[97], '@', pfu->nom, ren1, 0);
  inser(ren1, '/', snpun, ren1, 0);
  tranlin(6, true);

  if (!strcmp(pfu->arg, "REAL"))
    strcpy(ren1, fosa[98]);
  else
    strcpy(ren1, fosa[340]);
  inser(ren1, '@', pfu->nom, ren1, 0);
  tranlin(6, true);
  if (!strcmp(pfu->mfu, "REAL"))
    strcpy(ren1, fosa[99]);
  else
    strcpy(ren1, fosa[341]);
  inser(ren1, '@', pfu->nom, ren1, 0);
  tranlin(6, true);
  if (strcmp(pfu->arg, "REAL")) {
    inser(fosa[105], '@', pfu->nom, ren1, 0);
    tranlin(6, true);
  }
  strcpy(ren1, fosa[20]);
  tranlin(6, true);

  if (!strcmp(pfu->cla, "SPLINE")) {
    sprintf(cnfspl, "%d", pfu->nfspl);
/* p2c: ug2.pas, line 1297:
 * Note: Possible string truncation in assignment [145] */
    inser(fosa[336], '*', pfu->nom, ren1, 0);
    inser(ren1, '&', cnfspl, ren1, 0);
    tranlin(6, true);
  }

  if (strcmp(pfu->arg, "REAL")) {   /*generar arreglo de nombres*/
    inser(fosa[104], '@', pfu->nom, ren1, 0);
    inser(ren1, '/', snpun, ren1, 0);
    tranlin(3, false);
    ptx = ptxf;
    while (ptx != NULL) {
      if (ptx->ps == NULL) {
	strcpy(sfc, "'); ");
/* p2c: ug2.pas, line 1309:
 * Note: Possible string truncation in assignment [145] */
      } else
	strcpy(sfc, "',");
      sprintf(ren1, "'%s%s", ptx->val, sfc);
      tranlin(3, true);
      ptx = ptx->ps;
    }
  }

  if (W) {
    printf("FIN TABLA CONST K= %d %s\n", k, pl->con);
    UT = getchar();
  }
  btran = true;
  k++;
  ki = k;

  if (!bexp)   /* funcion en EXPER.*/
  {  /* guard.nombre y tipo:'F' */
    return;
  }
  nexp++;
  pex = (recexp *)Malloc(sizeof(recexp));
  strcpy(pex->nom, pfu->nom);
  pex->tipo = 'F';
  pex->ps = NULL;
  if (pexf == NULL)
    pexf = pex;
  else
    pexl->ps = pex;
  pexl = pex;
}


/***********************************************************PRNTR */
Void prntr()
{
  /*capacidad de nodos R individuales */
  nod[i-1].tamr = 2;   /* se supone<>1 !!!!!!!!no necesario!!!!!!!*/
  strcpy(nom1, nod[i-1].nom);   /* guardar nombre de nodo.Tran lo anterior: */
  tranhas(m, ptra);
  btran = false;
  binte = false;   /*no subin.va*/
  if (nod[i-1].sub != 1) {
    /*no tran por verflin*/
    resuno();   /*recoger subindice */
    /* if binte then begin ren1:='begin ';tranlin(ptra,false) end */
  } else
    k++;
  strcpy(ren1, fosa[19]);
  tranlin(ptra, true);   /*begin*/
  sprintf(ren1, "m_%s", nom1);
  tranlin(ptra, false);   /*!!!!VER!!!!*/
  btran = true;
  ki = k;
  absigu();
  bprcn = true;
  prinsim(false);   /*capacidad de nodo es expresion simple*/
  bprcn = false;
  tranhas(m, ptra);
  k = m;
  btran = false;
  strcpy(ren1, "; ");
  tranlin(ptra, false);
  if (binit)   /*en INIT inic u_ a 0 si no actualizar f_=m_-u_*/
    inser(fosa[10], '*', nom1, ren1, 0);
  else
    inser(fosa[519], '*', nom1, ren1, 0);
  tranlin(ptra, false);
  finpro(true);
  btran = true;
  if (!bexp)
    return;
  if (W) {
    printf("!!!!!!!PROCESANDO NOD.EXP[] %s\n", nom1);
    UT = getchar();
  }
  nexp++;   /* guard.nombre y tipo: 'N' */
  pex = (recexp *)Malloc(sizeof(recexp));
  strcpy(pex->nom, nom1);
/* p2c: ug2.pas, line 1360:
 * Note: Possible string truncation in assignment [145] */
  pex->tipo = 'N';
  pex->ps = NULL;
  if (pexf == NULL)
    pexf = pex;
  else
    pexl->ps = pex;
  pexl = pex;
}


/****************************************** agregar a arbol */
/***********************************************************PRNTC */
Void prntc()
{  /* procesar llamado a nodo tipo C o G L I D E (k esta antes de ( ) */
  Char lln[76];
  st10 cni;

  tranhas(m, ptra);
  btran = false;
  k += 2;
  sprintf(lln, "%s(", nom1);   /*saltar (   formar llamada en cn */
/* p2c: ug2.pas, line 1372:
 * Note: Possible string truncation in assignment [145] */
  recid();
  strcat(lln, nom);
/* p2c: ug2.pas, line 1373:
 * Note: Possible string truncation in assignment [145] */
  strcpy(nom1, nom);   /*guardar subindice en nom1*/
  /*!!!!! ver si es entero o excede!!!!!!!!!!!*/
  strcat(lln, ");");   /*completar llamada*/
/* p2c: ug2.pas, line 1375:
 * Note: Possible string truncation in assignment [145] */
  recid();
  errca(')');
  k++;
  sprintf(cni, "%d", i);
/* p2c: ug2.pas, line 1377:
 * Note: Possible string truncation in assignment [145] */
  sprintf(ren1, " begin _pxx:=_px; _nn:=_n; _n:=%s;_ievv:=iev; iev:=%s;",
	  cni, nom1);
  tranlin(ptra, true);
  limpbuf(ptra);
  strcpy(ren1, lln);
  tranlin(ptra, true);
  strcpy(ren1, "; _px:=_pxx; _n:=_nn; iev:=_ievv end;");
  tranlin(ptra, false);
  limpbuf(ptra);
  ki = k;
  btran = true;
  recid();   /* ver que sigue debe ser ; END ELSE   */
  if (b) {
    if (strcmp(nom, "END") && strcmp(nom, "ELSE"))
      error("END o ELSE expected");
    return;
  }
  if (ch == ';')
    k++;
  else
    errca(';');
}


/*******************************************************PONDBASE***/
Static Void pondbase()
{
  /*poner datos a tipo DBASE*/
  strcpy(pv->typ_, "ARRAY");
  strcpy(pv->typel, tipo);
  strcpy(pv->typtyp, "ARRAY");
  pv->apind = pnxf;
}


/******************************************************** STVNAME */
Void stvname(first, nom)
boolean first;
Char *nom;
{
  /*LINUX*/ boolean Wstv;

  /* guarda en arbol y hace lista apuntadores a var.de arbol.
   Si es primero en lista de variables entrar com first=true
   Si es variable GLIDER poner antes bg:=true */
  avar *PVPR;
  Char STR1[98];

/*LINUX*/ if (W) { W=false; Wstv=true;} else Wstv=false;
  if (W) {
    PVPR = NULL;
    printf("NOMBRE A AGREGAR A ARBOL %s\n", nom);
    if (first)
      printf("ES PRIMERO\n");
    else
      printf("NO PRIMERO\n");
    UT = getchar();
  }
  nomnue = true;   /* se prepara nuevo si no dispose!!!! */
  pv = (avar *)Malloc(sizeof(avar));
  pv->pa = NULL;
  pv->ps = NULL;
  strcpy(pv->nom, nom);
/* p2c: ug2.pas, line 1409:
 * Note: Possible string truncation in assignment [145] */
  pv->est = false;
  pv->psi = NULL;
  psi = NULL;   /*el nuevo no tiene sinonimos que le sigan*/
  pv->dim = dime;
  strcpy(pv->typel, typel);   /*17/10/1998*/
  pv->dbase = dbase;   /*anotar si es o no var. DBASE*/
  *pv->tipfun = '\0';
  pv->ret = 0;
  pv->tipof = false;   /* por ahora no es FORWARD */
  pv->tipop = false;   /*           ni PROCEDURE  */
  /*indicar si es MAIN procedimiento o funcion */
  strcpy(pv->prog, prog);
      /*va a elem. de arbol nomb.de proc. o nodo en proceso*/
  if (bn)
    pv->vame = true;
  else
    pv->vame = false;
  /*si es mensaje, true*/
  pv->nvcon = 0;

  if (dbase)   /*poner datos a tipo dbase*/
    pondbase();

  if (pvf == NULL)
    pvf = pv;   /* no habia nada en el arbol,anot. comie.*/
  else {   /* comienza revision de arbol */
    pva = pvf;
    pvx = pva;
    while (pva != NULL) {
      if (W)
	printf("EXPLORANDO ELEMENTO %s DEL ARBOL\n", pva->nom);
      if (!strcmp(pva->nom, nom)) {   /*AND (PVA^.PROG=PROG)*/
	if (W) {
	  printf("HALLADO SINONIMO DE PROC. O MENSAJE\n");
	  UT = getchar();
	}
	if (bprocp)   /*es procedimiento o VAR DE NODO*/
	{  /*poner en lista de sinonimos de pva*/
	  if (W)
	    printf("PONER EN LISTA DE SINONIMOS\n");
	  psi = pva->psi;   /*apunta a nil o primer sinonimo*/
	  if (psi == NULL) {   /*es primer sinonimo*/
	    pva->psi = pv;   /*apunta a primer sinonimo*/
	    if (W)
	      printf("ES PRIMER SINONIMO %s\n", pv->nom);
	    psi = pv;   /*PARA ESCRIBIRLO*/
	  } else {   /*poner sinonimo en la lista*/
	    psia = pva->psia;   /*apunta al ultimo*/
	    psia->psi = pv;
	  }
	  /*ya hay un sinonimo*/
	  pva->psia = pv;   /*guadar apuntador al ultimo*/
	  goto _L2;   /*terminada exploracion arbol*/
	}  /*si es parametro formal*/

	if (bn && pva->vame) {   /*es mensaje*/
	  if (W) {
	    printf("VARIABLE DE MENSAJE REPETIDA %s\n", nom);
	    UT = getchar();
	  }
	  nomnue = false;
	  goto _L2;
	}
	sprintf(STR1, "duplicated name %s", nom);
	error(STR1);

      }
      /*se hallo nombre igual*/
      /*proseguir exploracion de arbol*/
      if (strcmp(pva->nom, nom) > 0) {
	pvx = pva;
	pva = pva->pa;
      } else {
	pvx = pva;
	pva = pva->ps;
      }
    }  /*hallo apunt. a rama vacia; termina expl.arbol*/


    /*poner elemento nuevo en arbol*/
    if (strcmp(pvx->nom, nom) > 0)
      pvx->pa = pv;
    else
      pvx->ps = pv;
    pv->psi = NULL;   /*elemento nuevo; no hay sinonimos (por ahora)*/
    pv->psia = NULL;
  }
  /* ya hay algo en el arbol */
  /*fin del caso con arbol no vacio*/

  /* si es de los G poner largo y tipo y terminar. Si no    */
  /* poner el elemento (nuevo o no) en lista de apuntadores */

_L2:
  if (bg) {
    if (W)
      printf("AGREGAR VARIABLE TIPO GLIDER DBASE O PROCED.\n");
    pv->long_ = lc;
    strcpy(pv->typ_, tipo);
    pv->psi = NULL;
    pvafunc = pv;
    goto _L1;
    /**/
/* p2c: ug2.pas: Note: Deleting unreachable code [255] */
  }

  if (W) {
    if (psi == NULL)
      printf("NO HAY SINONIMOS\n");
    else {
      printf("HAY SINONIMOS\n");
      PVPR = pva->psia;
      printf("SE AGREGO SINONIMO %s  %s DE PROG %s\n",
	     pv->nom, PVPR->nom, prog);
    }
  }
  plv = (lvar *)Malloc(sizeof(lvar));
  plv->ps = NULL;   /*para lista de apunt. a variables agr.a arbol*/
  if (nomnue) {
    plv->pv = pv;
    *pv->typ_ = '\0';
  }  /* si nuevo apunta y borra tipo */
  else
    plv->pv = pva;
  /* si es repetido apuntar al original */
  /*ELSE!!!!!!!!!!no debe ocurrir!!!!!!!!!!!!*/
  if (first) {
    plvf = plv;
    plva = plv;
  } else {
    plva->ps = plv;
    plva = plv;
  }
  /* ya hay algo en la lista de apuntadores; agregar */

_L1:
/*LINUX*/ if (Wstv) W=true;
  if (!W)
    return;
  printf("SALE DE STVNAME\n");   /*SEARCH(pvf);*/
  scanf("%c%*[^\n]", &UT);
  getchar();
}  /* fin procedimiento stvname poner var. en arbol */


/***********************************************************BUSLI***/
Void busli(cind)
Char *cind;
{
  /* buscar numero de IL_NXX[IND]      */
  Char tl[4];   /* EL_NXX[IND]  EL_NXX[IND](NYY[IND]) */

  recid();
  sprintf(tl, "%.3s", nom);
/* p2c: ug2.pas, line 1513:
 * Note: Possible string truncation in assignment [145] */
  if (strcmp(tl, "EL_") && strcmp(tl, "IL_"))
    error("EL_ or IL_ expected");
  k = m + 3;   /*  saltar IL_ o EL_ en la linea */
  reno(true);   /* recoge nodo actual y subindice */
  i2 = i;
  if (!strcmp(tl, "IL_")) {
    if (nod[i-1].sub == 1)   /* no subindice */
      sprintf(cind, "%d", nod[i-1].il);
    else {
      sprintf(cind, "%d", nod[i-1].il - 1);
      sprintf(cind + strlen(cind), "+%s", nom2);
    }
    return;
  }

  i2 = i;
  strcpy(nom3, nom1);
  strcpy(nom4, nom2);   /* guardar datos nodo actual */
  if (W) {
    printf("EL DE NODO %d %s IND %s\n", i, nom1, nom2);
    UT = getch();
  }
  recid();   /* recoge lo que sigue a ] */
  if (ch != '(') {   /* no hay antecesor indicado */
    if (nod[i-1].sub == 1)   /* no subindice */
      sprintf(cind, "%d", nod[i-1].el);
    else {
      sprintf(cind, "%d", nod[i-1].el - 1);
      sprintf(cind + strlen(cind), "+%s", nom2);
    }
    /* es EL_           puede haber antecesor */
    return;
  }
  k++;
  reno(true);   /* recoger antec.numero i;nom. en nom1 con sub. nom2 */
  buselnl(i, i2, nom2, nom4, cind, nod[i2-1].sub);
  recid();
  if (ch != ')')
    error(") expected");
  k++;
  if (W) {
    printf("ANTECESOR (DESP.BUSELN)%d %s  SUB. %s  CIND %s\n",
	   i, nom1, nom2, cind);
    UT = getchar();
    /* si hay antecesor  es ch=(    */
    /*** ver si esta caso ant. L con subindice **/
  }
}


/**********************************************************BUSELN**/
Void buselnl(nant, nsuc, inant_, insuc_, cind, dimsuc)
short nant, nsuc;
Char *inant_, *insuc_;
Char *cind;
short dimsuc;
{
  /* pone en cind lista de entrada EL_NSUC[INSUC](NANT[INANT]) que es
si suc. no es tipo D : el-1+insuc;
si suc es tipo     D con antec.<>L  el-1+insuc+(inant-1)*dimsuc;
si suc es tipo     D con antec. =L  el-1+inant;                    */
  st10 inant, insuc;
  short ind;
  Char STR2[30];

  /* es sucesor tipo D */

  strcpy(inant, inant_);
  strcpy(insuc, insuc_);
  bulesu(nant, nsuc);   /* ver relac. antecesor sucesor; el a nbel  */
  if (nod[nsuc-1].tipo != 'D') {
    calel(nbel, insuc, cind);
    return;
  }
  if (nod[nant-1].tipo == 'L') {
    calel(nbel, inant, cind);
    return;
  }
  calel(nbel, insuc, cind);
      /*calc. el del sucesor+ind.suc.-1, pone en cind*/
  if (!strcmp(inant, "1"))  /* hay subid. en antecesor */
    return;
  esnum = (sscanf(inant, "%d", &vind) == 0);
  if (esnum == 0) {
    vind--;

    sprintf(inant, "%d", vind);
/* p2c: ug2.pas, line 1569:
 * Note: Possible string truncation in assignment [145] */
  } else {
    sprintf(inant, "(%s-1)", strcpy(STR2, inant));
/* p2c: ug2.pas, line 1570:
 * Note: Possible string truncation in assignment [145] */
  }
  if (dimsuc > 1) {
    sprintf(insuc, "%d", dimsuc);
/* p2c: ug2.pas, line 1571:
 * Note: Possible string truncation in assignment [145] */
    sprintf(inant + strlen(inant), "*%s", insuc);
/* p2c: ug2.pas, line 1571:
 * Note: Possible string truncation in assignment [145] */
  }
  if (esnum != 0) {
    sprintf(cind + strlen(cind), "+%s", inant);
    return;
  }
  esnum = (sscanf(cind, "%d", &ind) == 0);
  ind += vind;
  sprintf(cind, "%d", ind);
}


/**********************************************************ABSIGU   */
Void absigu()
{
  /*absorber y verificar := */
  recid();
  if (ch != ':' && pl->con[k] != '=')
    error(":= expected");
  k += 2;
}


/********************************************************** CALEL */
Void calel(elist, subno, res)
short elist;
Char *subno;
Char *res;
{
  /* calc.el */
  sprintf(res, "%d", elist);
  if (W)
    printf("LA EL DEL SUCESOR ES %s  SU SUBIN. ES %s\n", res, subno);
  if (!strcmp(subno, "1"))   /* si hay sub. restar 1 y sumar indice */
    return;
  esnum = (sscanf(subno, "%d", &vind) == 0);
  elist--;   /* si es numerico esnum=0 */

  if (esnum == 0)
    elist += vind;
  sprintf(res, "%d", elist);
  if (esnum != 0) {
    sprintf(res + strlen(res), "+%s", subno);

  }
}


/*********************************************************BULESU **/
Void bulesu(na, ns)
short na, ns;
{
  /*busca el de antec. na sucesor ns, pone en nbel*/
  boolean b = true;

  if (bproced) {   /*si estamos en procedimiento, no hay antecesor*/
    nbel = nod[ns-1].el;
    return;
  }
  pna = nod[na-1].apns;
  while (pna != NULL && b)   /* buscar en lista de sucesores del na */
  {  /* hasta hallar el ns                   */
    if (pna->num == ns) {
      b = false;
      nbel = pna->nueli;
    }
    pna = pna->pns;
  }
  if (W)
    printf("BULESU HALLO EL CORRESP. A ANTEC.SU EL ES %d\n", nbel);
  if (b) {
    error("predecessor or succesor node not defined");

  }
}


/********************************************************** PRINSIM */
Void prinsim(varc)
boolean varc;
{
  /* procesar asignativa;
     guard.experimentales no nodo ; si es de ret. ret debe indicar
     orden; gener.estadist.ant.y post. */
  st10 nomr, cret;

  if (W) {
    printf("PRINSIM \n");
    UT = getchar();
  }
  bsimpl = true;   /*se procesa asignativa*/
  strcpy(nomr, nom4);
/* p2c: ug2.pas, line 1635:
 * Note: Possible string truncation in assignment [145] */
  if (!bexp) {  /*Delphi 2.03.2001*/  
    recexpr();  /*recoger la <expresion> ************/
    /*Delphi 2.03.2001*/
    if (!strcmp(nomr, "WINDOWWIDTH"))
      UserWindowSizes[0] = true;
    if (!strcmp(nomr, "WINDOWHEIGHT"))
      UserWindowSizes[1] = true;
  }  /*Delphi 2.03.2001*/
  else {
    recid();
    if (!bnumer)
      error("number expected");
    if (W) {
      printf("!!!!!!!PROCESANDO VAR.EXP %s\n", nom4);
      printf("ANTES DE ESTA HAY %d\n", nexp);
      UT = getchar();
      pex = pexf;
      while (pex != NULL) {
	puts(pex->nom);
	pex = pex->ps;
      }
    }
    recid();
    if (ch != ';')
      error("; expected");
    k++;
    if (!bprcn) {
      nexp++;   /* guard.nombre y tipo:'V' */
      pex = (recexp *)Malloc(sizeof(recexp));
      strcpy(pex->nom, nom4);
/* p2c: ug2.pas, line 1651:
 * Note: Possible string truncation in assignment [145] */
      pex->tipo = 'V';
      pex->ps = NULL;
      if (pexf == NULL)
	pexf = pex;
      else
	pexl->ps = pex;
      pexl = pex;
    }
  }
  /* variable simple o nodo !!!!!!!!!! en EXPER.*/
  /*estadisticas posteriores en NETWORK e INIT */
  if (bestv) {
    proesvp();
    bestv = false;
  }

  if (ret > 0 && varc) {
    tranhas(k, ptra);
    ki = k;
    btran = false;
    sprintf(cret, "%d", ret - 1);
/* p2c: ug2.pas, line 1660:
 * Note: Possible string truncation in assignment [145] */
    sprintf(ren1, "for _i:=1 to %s do _%s_DEL[_i]:=%s;", cret, nomr, nomr);
    tranlin(ptra, true);
    limpbuf(ptra);
    btran = true;
  }
  bsimpl = false;
}


/********************************************************* FINPRO */
Void finpro(bend)
boolean bend;
{
  /* ter.proc.G con end o end; aj. ki */
  recid();   /* recoge lo que sigue al ) o nombre del proc.*/
  if (bend)
    strcpy(ren1, fosa[29]);
  else
    *ren1 = '\0';
  /* poner end o vacio */
  if (!b && ch == ';') {
    k++;
    ki = k;   /*recogido ;  */
    strcat(ren1, ";");
  } else if (strcmp(nom, "END") && strcmp(nom, "ELSE"))
    error("; or END or ELSE expected");
  else {
    ki = m - 1;   /*k:=k+1*/
    /*recogido END o ELSE*/
  }

  tranlin(ptra, false);
}





/* End. */
